;*************************************************************
; DIV - ANDR
;  LONGLIGHT    CARRY-DMX = 2 
; DMX - ,   - , GOBO -
;************************************************************
;   Filename:           carrydmx.asm
;   Date:                2004
;   File Version:       1.00
;   Assembler:          mpasm 1.40
;   Author:             Bogdanov Andrew
;************************************************************
;  LIST   p=16C73  ; cp=off=1. 3pwrt|on=1. 2wdt|on=1. =HS   *
 __CONFIG b'00000011000010'        ;   CP on      *
;__CONFIG b'11111111111110'        ;    CP off    *
;************************************************************
#include pic73.mac ;                                     *
;************************************************************
#define  Fweit         Flags1,1 ; a  .
#define  FStopRoller   Flags2,1 ; stop   
#define  FStopCap      Flags2,2 ; stop  
;******************** Ports Bits ****************************
#define  Musik     PORTA,2     ;  
;----------lk-------------------------------------------------*
;#define  RollerA   PORTC,1  ;  
;#define  RollerB   PORTC,2  ;
;----------lk-------------------------------------------------*
#define  RollerA   PORTC,1  ;  
#define  RollerB   PORTC,2  ;
;----------lk-------------------------------------------------*
#define  CapA      PORTC,4  ;    =A= 
#define  CapB      PORTC,5  ;    =B=
;************************************************************
;           Register Definitions  20h - 7fh
;******  Roller *************************************
Rollstep    equ   0x20  ; Roller    
Rollcount   equ   0x21  ; Roller   
Rollswith   equ   0x22  ; Roller   
RollSqw     equ   0x23  ; Roller    
LevelRoller equ   0x24  ;    - 
SpeedRoller equ   0x25  ; Speed   - 
;------------------------------------------------------------
Capstep     equ   0x28  ;    
Capcount    equ   0x29  ;   
Capswith    equ   0x2A  ;   
CapSqw      equ   0x2B  ;    
LevelCap    equ   0x2C  ;  
SpeedCap    equ   0x2D  ; Speed  
;***************************************************************
Divider     equ   0x40   ; - .swith  
Flags1      equ   0x41   ; ,   
Flags2      equ   0x42   ; ,   
CountUniv   equ   0x43   ;   (+RTCC)
CountPosl   equ   0x44   ; (+RTCC)    LB
CountPosh   equ   0x45   ;     HB
CountProg   equ   0x46   ; (+RTCC)    "a"
DataTemp    equ   0x47   ;     
DataTab     equ   0x48   ;    
AdrTab      equ   0x49   ;   
TempForAll  equ   0x4A   ;
;*************************************************************
konst_r    equ    d'090'   ;     
; p k30=time50sec ;r 75=120/ ;
konst_p     equ   d'033'  ; 15  .  off-lamp
konst_     equ   d'003'  ; 03  .  off-roll
konst_m     equ   d'050'  ; 37     
;*************************************************************
        ORG     0        ;  
;***********************************************************************
        goto    Start    ;    
;*************************************************************
TabSpeed: addwf PC,f ;  001- 250-
 dt  .001,.002,.003,.004,.005,.006,.007,.008
 dt  .010,.012,.015,.030,.050,.100,.150,.250
;*************************************************************
long_tab  equ  .063 ;    
TabComand: addwf PC,F ;  W-    210
; 4x,5x - CAP  -    . 
; 8x,9x - ROLL -  
; Ax,Bx -       
; Cx,Dx -       
;*************************************************************
; Version = LongLight - 2 motor
;*************************************************************
;    :   0  31
    dt  0x4F,0x8F,0x9F,0x8F,0x9F,0x8F,0x9F,0x8F ;
    dt  0x9F,0x8F,0x9F,0x8F,0x9F,0x8F,0x9F,0x8F ;
    dt  0x95,0x5F,0x4F,0x5F,0x4F,0x5F,0x4F,0x5F ;
    dt  0x9D,0x90,0x8D,0x80,0x9D,0x90,0x8D,0x81 ;
;    :   32  63
    dt  0x4F,0x5F,0x4F,0x5F,0x4F,0x5F,0x4F,0x5F ;
    dt  0x9F,0x9F,0x8F,0x8F,0x9F,0x9F,0x8F,0x8F ;
    dt  0x9F,0x9F,0x8F,0x8F,0x9F,0x9F,0x8F,0x8F ;
    dt  0x4A,0x5A,0x4A,0x5A,0x4A,0x5A,0x4A,0x5A ;
;*************************************************************
;    :   64  95
    dt  0x9F,0x8F,0x9F,0x8F,0x9F,0x8F,0x9F,0x8F ;
    dt  0x9F,0x8F,0x9F,0x8F,0x9F,0x8F,0x9F,0x8F ;
    dt  0x9F,0x8F,0x9F,0x8F,0x9F,0x8F,0x9F,0x8F ;
    dt  0x9F,0x8F,0x9F,0x8F,0x9F,0x8F,0x9F,0x8F ;
;    :   96  127
    dt  0x9F,0x8F,0x9F,0x8F,0x9F,0x8F,0x9F,0x8F ;
    dt  0x9F,0x8F,0x9F,0x8F,0x9F,0x8F,0x9F,0x8F ;
    dt  0x9F,0x8F,0x9F,0x8F,0x9F,0x8F,0x9F,0x8F ;
    dt  0x9F,0x8F,0x9F,0x8F,0x9F,0x8F,0x9F,0x8F ;
;    :   128  159
    dt  0x9F,0x8F,0x9F,0x8F,0x9F,0x8F,0x9F,0x8F ;
    dt  0x9F,0x8F,0x9F,0x8F,0x9F,0x8F,0x9F,0x8F ;
    dt  0x9F,0x8F,0x9F,0x8F,0x9F,0x8F,0x9F,0x8F ;
    dt  0x9F,0x8F,0x9F,0x8F,0x9F,0x8F,0x9F,0x8F ;
;    :   160  191
    dt  0x9F,0x8F,0x9F,0x8F,0x9F,0x8F,0x9F,0x8F ;
    dt  0x9F,0x8F,0x9F,0x8F,0x9F,0x8F,0x9F,0x8F ;
    dt  0x9F,0x8F,0x9F,0x8F,0x9F,0x8F,0x9F,0x8F ;
    dt  0x9F,0x8F,0x9F,0x8F,0x9F,0x8F,0x9F,0x8F ;
;    :   192  216
    dt  0x9F,0x8F,0x9F,0x8F,0x9F,0x8F,0x9F,0x8F ;
    dt  0x9F,0x8F,0x9F,0x8F,0x9F,0x8F,0x9F,0x8F ;
    dt  0x9F,0x8F,0x9F,0x8F,0x9F,0x8F,0x9F,0x8F ;
    dt  0x9F,0x8F,0x9F,0x8F,0x9F,0x8F,0x9F,0x8F ;
;***********************************************************************
        ORG    100H                 ;  
;***********************************************************************
Start:                              ; Main Programm
            bsf         STATUS,RP0  ; c 1
            movlw       b'00111111' ; A0-4 =in
            movwf       TRISA       ; A5  = out
            movlw       b'11111111' ; B0-B7 - inputs
            movwf       TRISB       ; DMX address
            movlw       b'10000000' ; C0-C6-out stepmotor
            movwf       TRISC       ; C7=RX,C6=TX
            movlw       b'00000000' ; 1:2-HS->Presc->Tmr0,
            movwf       OPTIONR     ;   :50 !!!
            movlw       b'00000100' ;  A2,4,5
            movwf       ADCON1      ; analog A0,1,3
            movlw       b'00100000' ;  
            movwf       PIE1        ; USART
            movlw       d'000'      ; =0, brg=0
            movwf       SPBRG       ; USART
            movlw       b'00100010' ;  BRGH =1 high
            movwf       TXSTA       ; USART      bit2 =0 low
            bcf         STATUS,RP0  ; c 0
;*************************************************************
            movlw       b'10011101' ;  
            movwf       ADCON0      ; ADC
            movlw       b'10010000' ;  
            movwf       RCSTA       ; USART
            movlw       b'00000000' ; (bit 5 = 0   data
            movwf       PIR1        ; USART -  !!!
;            movlw       b'11000000' ;  
            movlw       b'00000000' ; off 
            movwf       INTCON      ; 
;.          movlw       b'00001100' ; mode  1
;           movwf       CCP1CON     ; adr 17h
;           movlw       b'00001100' ; mode  2
;           movwf       CCP2CON     ; adr 1dh
            movlw       .063         ;   - 8 
            movwf       PR2         ; 63 = 39  (F=10Mhz)
            movlw       b'00000100' ;  2 - = 1:1
            movwf       T2CON       ; - = 1:1
;------------------------------------------------------------
        movlw   0x20       ; 
        movwf   FSR        ; 
clear_mem:                 ;
        clrf    INDF       ; 
        incf    FSR,f      ; ..   
        cpi     FSR,0x7F   ;  = 0
        jnz     clear_mem  ;
        clrwdt             ;  WDT 
;-------------------------------------------------------------
        mvi  AdrTab,0xff      ;    !!!
;*************************************************************
BaseCarryCuc: ; --      -----
;*************************************************************
        clrwdt             ;  WDT 
        btfss    TMR0,6    ; -6-   50  !!!
        goto    NoPlus     ;  6=0 -> 
        clrf     TMR0      ;  6=1 ->  
        incf    CountUniv,f;  , Program
        jnz     noCountU   ;     
        incf    CountProg,f;     | 
        incf    CountPosl,f;   |  
noCountU:                  ;                |   
        incf    Rollcount,f;  
        incf    Capcount,f ;
;-------------------------------------------------
NoPlus:
;-------------------------------------------------
        call    RollerMove  ;   ( )
        call    CapMove     ;   ( )
;-------------------------------------------------
        incf    Divider,f     ; 
        movlw   0x0f          ;   
        andwf   Divider,w     ;  
        jnz     BaseCarryCuc  ;   
;-------------------------------------------------
        cpi     Divider,0x00  ;  
        jz      CheckRoller   ;   
        cpi     Divider,0x50  ;  
        jz      CheckCap      ;    
        cpi     Divider,0xA0  ;  
        jz      CheckSwith    ;  
; ------      ---------------
        btfsc   Fweit        ;    
        goto    mus_gate     ;  =1,  
        cpi     CountProg,konst_m ;   
        jc      BaseCarryCuc ; ,      
        clrf    CountProg    ;   
        bsf     Fweit        ;   (=1)  
        goto    BaseCarryCuc ;   
mus_gate:
        btfss   Musik        ;   ?
        goto    BaseCarryCuc ;  
        bcf     Fweit        ; . -   
        call    FollowProg   ;    
        goto    BaseCarryCuc  ;   
;**********************************************************
CheckSwith:  ;     
;**********************************************************
        call    Posle         ;   10  
        goto    BaseCarryCuc ;   
;**********************************************************
CheckCap: ;   
;**********************************************************
        bcf     FStopCap      ;  STOP
        cpi     LevelCap,.124 ;  121  134 
        jc      job_C         ; <124  
        cpi     LevelCap,.131 ;
        jc      BaseCarryCuc  ;  
job_C:                        ; >131  
        bsf     FStopCap      ;  
        mov     SpeedCap,LevelCap
        btfsc   LevelCap,7    ;   > 127 
        comf    SpeedCap,f    ;  
        rrf     SpeedCap,f    ;
        rrf     SpeedCap,f    ;
        rrf     SpeedCap,f    ;
        movlw   0x0f          ;
        andwf   SpeedCap,w    ; 
        call    TabSpeed      ;   
        movwf   SpeedCap      ;  
        goto    BaseCarryCuc  ;   
;**********************************************************
CheckRoller: ;     
;**********************************************************
        bcf     FStopRoller      ;  STOP
        cpi     LevelRoller,.124 ;  121  134 
        jc      job_R            ; <124  
        cpi     LevelRoller,.131 ;
        jc      BaseCarryCuc     ;  
job_R:                           ; >131  
        bsf     FStopRoller      ;  
        mov     SpeedRoller,LevelRoller
        btfsc   LevelRoller,7    ;   > 127 
        comf    SpeedRoller,f    ;  
        rrf     SpeedRoller,f    ;  
        rrf     SpeedRoller,f    ;
        rrf     SpeedRoller,f    ;
        movlw   0x0f             ;
        andwf   SpeedRoller,w    ;  Rollera
        call    TabSpeed         ;   
        movwf   SpeedRoller      ;   Rollera
        goto    BaseCarryCuc     ;   
;**************************************************************
FollowProg:  ;    
;**************************************************************
        clrf    PCLATH          ;
        incf    AdrTab,f        ;  
        cpi     AdrTab,long_tab ;   
        jnz     foll_obx        ;   arg = const
        clrf    AdrTab          ;    = 0
foll_obx:
        movf    AdrTab,w        ;   -> W
        call    TabComand       ;  
        movwf   DataTab         ;  
;==========   ==================================
        movwf   DataTemp        ;   
        movlw   b'11100000'     ;
        andwf   DataTemp,f      ;
        cpi     DataTab,0x30    ;   
        jc      AnalizGobo      ;     
;==========================================================
; 4x,5x - 4  CAP  -    . 
; 8x,9x - 8  ROLL -  
; Ax,Bx - 10       
; Cx,Dx - 12       
        cpi     DataTemp,b'01000000' ; 40h   
        jz      AnalizCap            ;      
        cpi     DataTemp,b'10000000' ; 80h
        jz      AnalizRoller         ;
        cpi     DataTemp,b'10100000' ; A0h
        jz      AnalizTogethe        ;
;-----------------------------------------------------------------------
        call    AnalizCap            ;   
        movlw   b'00010000'
        xorwf   DataTab,f            ;  
        goto    AnalizRoller         ;
;-----------------------------------------------------------------------
AnalizTogethe:                       ;   
        call    AnalizCap            ;
        goto    AnalizRoller         ;
;-----------------------------------------------------------------------
AnalizGobo:                        ;     
         return                    ;    
;-----------------------------------------------------------------------
AnalizRoller:   ;  = + 4=
         mov     DataTemp,DataTab  ;
         btfss   DataTemp,4        ;   = 0
         call    invers            ;
         rlf     DataTemp,f        ;  32 
         rlf     DataTemp,f        ;   - 16 
         rlf     DataTemp,f        ;  
         movlw   b'11111000'       ;
         andwf   DataTemp,f        ;
         mov     LevelRoller,DataTemp ;  
         return                       ;  
;-----------------------------------------------------------------------
AnalizCap: ; 40h  = + 4=
         mov     DataTemp,DataTab  ;
         btfss   DataTemp,4        ;   = 0
         call    invers            ;
         rlf     DataTemp,f        ;  32 
         rlf     DataTemp,f        ;   - 16 
         rlf     DataTemp,f        ;  
         movlw   b'11111000'       ;
         andwf   DataTemp,f        ;
         mov     LevelCap,DataTemp ;   
         return
invers:
         comf    DataTemp,f        ; 
         nop
         bcf     DataTemp,4        ; 
         return
;***********************************************************************
Posle:        ;    3 
;***********************************************************************
        btfss   Musik          ;   
        goto    posl_nogate    ;    ?
        clrf    CountPosl      ;   
        clrf    CountPosh      ;   
        return
posl_nogate:                   ;  
        cpi     CountPosl,.250 ;    
        rnz                    ; ret,      
        incf    CountPosh,f    ;
        cpi     CountPosh,konst_;  3 
        jnz     posl_noCap       ;
        mvi     LevelCap,.130    ; STOP 
        mvi     LevelRoller,.130 ; STOP  
posl_noCap:
        cpi     CountPosh,konst_p;  15 
        rnz                      ;      
        clrf    CountPosl        ;   
        return
;************************************************************
        ORG     500h
;************************************************************
CapMove:  ;   =  
;************************************************************
        btfss   FStopCap    ;   
        return              ;  
        btfsc   LevelCap,7  ;  
        goto    CapLeft     ; 
        movf    SpeedCap,w  ;  : c
        subwf   Capcount,w  ;   
        btfss   STATUS,CR   ;   
        goto    cross_C1    ; ,  
        clrf    Capcount    ;   
        incf    Capstep,f   ;   
        jnz     cross_C1    ;   = 0  
        decf    Capswith,f  ;     
        movlw   b'00000011' ; (   )
        andwf   Capswith,f  ;   
cross_C1:                   ;
        decf    CapSqw,f    ;  
        mvi     PCLATH,5    ; org 500h
        movf    Capswith,w  ;  
        addwf   PC,f
        goto    Cap1varR4   ; 4
        goto    Cap1varR3   ; 3
        goto    Cap1varR2   ; 2
        goto    Cap1varR1   ; 1
;-------------------------------------------------------------
Cap1varR1: ;     
        cmp     CapSqw,Capstep  ;   
        btfsc   STATUS,0        ;
        goto    cst100010       ;   - 1->0
        goto    cst100100       ;   - 0->1
;-------------------------------------------------------------
Cap1varR2: ;     
        cmp     CapSqw,Capstep  ;   
        btfsc   STATUS,0
        goto    cst010010       ;   - 1->0
        goto    cst100010       ;   - 0->1
;-------------------------------------------------------------
Cap1varR3: ;     
        cmp     CapSqw,Capstep  ;   
        btfsc   STATUS,0
        goto    cst010100       ;   - 1->0
        goto    cst010010       ;   - 0->1
;-------------------------------------------------------------
Cap1varR4: ;     
        cmp     CapSqw,Capstep  ;   
        btfsc   STATUS,0
        goto    cst100100       ;   - 1->0
        goto    cst010100       ;   - 0->1
;-------------------------------------------------------------
CapLeft:  ;   =   ()
;-------------------------------------------------------------
        movf    SpeedCap,w
        subwf   Capcount,w  ;   
        btfss   STATUS,CR   ;   
        goto    cross_k1    ; ,  
        clrf    Capcount    ;   
        incf    Capstep,f   ;   
        jnz     cross_k1    ;   = 0  
        incf    Capswith,f  ; ???    
        movlw   b'00000011' ; (   )
        andwf   Capswith,f  ;   
cross_k1:                   ;
        incf    CapSqw,f    ;  
        mvi     PCLATH,5    ; org 500h
        movf    Capswith,w  ;
        addwf   PC,f
        goto    Cap1varL4   ;
        goto    Cap1varL3   ;
        goto    Cap1varL2   ;
        goto    Cap1varL1   ;
;-------------------------------------------------------------
Cap1varL1: ;     
        cmp     CapSqw,Capstep ;   
        btfss   STATUS,0        ;
        goto    cst100010       ;   - 1->0
        goto    cst100100       ;   - 0->1
;-------------------------------------------------------------
Cap1varL2: ;     
        cmp     CapSqw,Capstep ;   
        btfss   STATUS,0
        goto    cst010010       ;   - 1->0
        goto    cst100010       ;   - 0->1
;-------------------------------------------------------------
Cap1varL3: ;     
        cmp     CapSqw,Capstep ;   
        btfss   STATUS,0
        goto    cst010100       ;   - 1->0
        goto    cst010010       ;   - 0->1
;-------------------------------------------------------------
Cap1varL4: ;     
        cmp     CapSqw,Capstep ;   
        btfss   STATUS,0
        goto    cst100100       ;   - 1->0
        goto    cst010100       ;   - 0->1
;-------------------------------------------------------------
cst100010:           ; 1
     bsf  CapA       ;    =A= 
     bcf  CapB       ;    =B= 
     clrf PCLATH
     return          ;
cst100100:           ; 2
     bsf  CapA       ;    =A= 
     bsf  CapB       ;    =B= 
     clrf PCLATH
     return          ;
cst010010:           ; 3
     bcf  CapA       ;    =A= 
     bcf  CapB       ;    =B= 
     clrf PCLATH
     return          ;
cst010100:           ; 4
     bcf  CapA       ;    =A= 
     bsf  CapB       ;    =B= 
     clrf PCLATH
     return          ;
;************************************************************
RollerMove:  ;   =  
;************************************************************
        btfss   FStopRoller ;   
        return              ;  
        btfss   LevelRoller,7 ;  
        goto    RollerLeft    ; 
        movf    SpeedRoller,w ;  : c
        subwf   Rollcount,w ;   
        btfss   STATUS,CR   ;   
        goto    cross_r1    ; ,  
        clrf    Rollcount   ;   
        incf    Rollstep,f  ;   
        jnz     cross_r1    ;   = 0  
        decf    Rollswith,f ;     
        movlw   b'00000011' ; (   )
        andwf   Rollswith,f ;   
cross_r1:                   ;
        decf    RollSqw,f   ;  
        mvi     PCLATH,5    ; org 500h
        movf    Rollswith,w ;  
        addwf   PC,f
        goto    Roll1varR4   ; 4
        goto    Roll1varR3   ; 3
        goto    Roll1varR2   ; 2
        goto    Roll1varR1   ; 1
;-------------------------------------------------------------
Roll1varR1: ;     
        cmp     RollSqw,Rollstep;   
        btfsc   STATUS,0        ;
        goto    ust100010       ;   - 1->0
        goto    ust100100       ;   - 0->1
;-------------------------------------------------------------
Roll1varR2: ;     
        cmp     RollSqw,Rollstep;   
        btfsc   STATUS,0
        goto    ust010010       ;   - 1->0
        goto    ust100010       ;   - 0->1
;-------------------------------------------------------------
Roll1varR3: ;     
        cmp     RollSqw,Rollstep;   
        btfsc   STATUS,0
        goto    ust010100       ;   - 1->0
        goto    ust010010       ;   - 0->1
;-------------------------------------------------------------
Roll1varR4: ;     
        cmp     RollSqw,Rollstep;   
        btfsc   STATUS,0
        goto    ust100100       ;   - 1->0
        goto    ust010100       ;   - 0->1
;-------------------------------------------------------------
RollerLeft:  ;   =   ()
;-------------------------------------------------------------
        movf    SpeedRoller,w
        subwf   Rollcount,w ;   
        btfss   STATUS,CR   ;   
        goto    cross_l1    ; ,  
        clrf    Rollcount   ;   
        incf    Rollstep,f  ;   
        jnz     cross_l1    ;   = 0  
        incf    Rollswith,f ; ???    
        movlw   b'00000011' ; (   )
        andwf   Rollswith,f ;   
cross_l1:                   ;
        incf    RollSqw,f   ;  
        mvi     PCLATH,5    ; org 500h
        movf    Rollswith,w ;
        addwf   PC,f
        goto    Roll1varL4   ;
        goto    Roll1varL3   ;
        goto    Roll1varL2   ;
        goto    Roll1varL1   ;
;-------------------------------------------------------------
Roll1varL1: ;     
        cmp     RollSqw,Rollstep;   
        btfss   STATUS,0        ;
        goto    ust100010       ;   - 1->0
        goto    ust100100       ;   - 0->1
;-------------------------------------------------------------
Roll1varL2: ;     
        cmp     RollSqw,Rollstep;   
        btfss   STATUS,0
        goto    ust010010       ;   - 1->0
        goto    ust100010       ;   - 0->1
;-------------------------------------------------------------
Roll1varL3: ;     
        cmp     RollSqw,Rollstep;   
        btfss   STATUS,0
        goto    ust010100       ;   - 1->0
        goto    ust010010       ;   - 0->1
;-------------------------------------------------------------
Roll1varL4: ;     
        cmp     RollSqw,Rollstep;   
        btfss   STATUS,0
        goto    ust100100       ;   - 1->0
        goto    ust010100       ;   - 0->1
;-------------------------------------------------------------
ust100010:              ; 1
     bsf  RollerA       ;    =A= 
     bcf  RollerB       ;    =B= 
     clrf PCLATH
     return             ;
ust100100:              ; 2
     bsf  RollerA       ;    =A= 
     bsf  RollerB       ;    =B= 
     clrf PCLATH
     return             ;
ust010010:              ; 3
     bcf  RollerA       ;    =A= 
     bcf  RollerB       ;    =B= 
     clrf PCLATH
     return             ;
ust010100:              ; 4
     bcf  RollerA       ;    =A= 
     bsf  RollerB       ;    =B= 
     clrf PCLATH
     return             ;
;**************************************************************
  End  ;    BrSoft Copyright (C) 2004 Bogdanov Andrew
;**************************************************************






