;*************************************************************
;  (DMX)    CARRY
;************************************************************
;   Filename:           carrydmx.asm
;   First Date:         14 may     2003
;   Last  Date:                    2003
;   File Version:       1.00
;   Assembler:          mpasm 1.40
;   Author:             Bogdanov Andrew
;   E-Mail:             BrSoft@tsrv.ru
;   Info:               Book N4 page
;************************************************************
;  LIST   p=16C73  ; cp=off=1. 3pwrt|on=1. 2wdt|on=1. =HS   *
 __CONFIG b'00000011000010'        ;   CP on      *
;__CONFIG b'11111111111110'        ;    CP off    *
;************************************************************
#include pic73.mac ;                                     *
;************************************************************
;           Bit Definitions                                 *
;************************************************************
#define  flag_0   Flagsdmx,0  ;                       *
#define  flag_1   Flagsdmx,1  ;                *
#define  flag_2   Flagsdmx,2  ;                  *
#define  flag_3   Flagsdmx,3  ;  DMX                 *
#define  flag_d   Flagsdmx,4  ; news                       *
;************************************************************
;#define  Fdoli         Flags1,0 ;   
#define  Fweit         Flags1,1 ; a  .
#define  Freset        Flags1,2 ;   Switcher
;#define  Fswim         Flags1,3 ;  GOBO
;------------------------------------------------------------
#define  FdirectGobo   Flags2,0 ;  
#define  FStopRoller   Flags2,1 ; stop   
#define  FStopCap      Flags2,2 ; stop  
#define  Fadc          Flags2,3 ;  -
;******************** Ports Bits ****************************
#define  Musik     PORTA,2     ;  
#define  faza50    PORTA,4     ;  50 
#define  Lampa     PORTA,5     ; optron 3010  
;-----------------------------------------------------------*
#define  RollerA   PORTC,0  ;    =A= .
#define  RollerB   PORTC,3  ;    =B=
#define  CapA      PORTC,4  ;    =A= 
#define  CapB      PORTC,5  ;    =B=
;#define  GoboA     PORTC,1  ;    =A= Gobo
;#define  GoboB     PORTC,2  ;    =B=
;************************************************************
;           Register Definitions  20h - 7fh
;******  Roller *************************************
Rollstep    equ   0x20  ; Roller    
Rollcount   equ   0x21  ; Roller   
Rollswith   equ   0x22  ; Roller   
RollSqw     equ   0x23  ; Roller    
LevelRoller equ   0x24  ;    - 
SpeedRoller equ   0x25  ; Speed   - 
;------------------------------------------------------------
Capstep     equ   0x28  ;    
Capcount    equ   0x29  ;   
Capswith    equ   0x2A  ;   
CapSqw      equ   0x2B  ;    
LevelCap    equ   0x2C  ;  
SpeedCap    equ   0x2D  ; Speed  
;------------------------------------------------------------
Gobocount   equ   0x30  ; GOBO  
Shimswith   equ   0x31  ; GOBO
GoboSunrise equ   0x32  ; GOBO   
LevelGobo   equ   0x33  ;   GOBO
MestoGobo   equ   0x34  ;   GOBO
TempGobo    equ   0x35  ; .    GOBO
MaskaGobo   equ   0x36  ; .    GOBO
;-------------------------------------------------------------
Faza        equ   0x38  ;  
FazaBright  equ   0x39  ;     50 Hz
LevelBright equ   0x3A  ;   
HandBright  equ   0x3B  ;    
VoltBright  equ   0x3C  ;    
;***************************************************************
Divider     equ   0x40   ; - .swith  
Flags1      equ   0x41   ; ,   
Flags2      equ   0x42   ; ,   
CountUniv   equ   0x43   ;   (+RTCC)
CountPosl   equ   0x44   ; (+RTCC)    LB
CountPosh   equ   0x45   ;     HB
CountProg   equ   0x46   ; (+RTCC)    "a"
DataTemp    equ   0x47   ;     
DataTab     equ   0x48   ;    
AdrTab      equ   0x49   ;   
TempForAll  equ   0x4A   ;
;*************************************************************
dmx_0       equ  0x50   ; 0-
dmx_1       equ  0x51   ;  
dmx_2       equ  0x52   ; GOBO + OLOR + RainBow + Strob
dmx_3       equ  0x53   ;  
dmx_4       equ  0x54   ;    
dmx_5       equ  0x55   ;  
dmx_6       equ  0x56   ;  
dmx_7       equ  0x57   ;  
dmx_8       equ  0x58   ;
;*************    DMX *************************
Flagsdmx    equ   0x70  ; \   
temp_cnt    equ   0x71  ; \ Int    
temp_rx     equ   0x72  ; \ Int     
temp_s      equ   0x73  ; \ Int  
temp_w      equ   0x74  ; \
temp_fsr    equ   0x75  ; \ Int    
rx          equ   0x76  ;   DMX
mode_int    equ   0x77  ;    
first       equ   0x78  ;    
tekuch      equ   0x79  ;    
channel     equ   0x7A  ;    
;*************************************************************
konst_r    equ    d'090'   ;     
; p k30=time50sec ;r 75=120/ ;
konst_p     equ   d'033'  ; 15  .  off-lamp
konst_     equ   d'003'  ; 03  .  off-roll
konst_m     equ   d'050'  ; 37     
konst_mains equ   d'137'  ;   ,  220 
konst_dark  equ   d'050'  ;   
;*************************************************************
        ORG     0        ;  
;***********************************************************************
        goto    Start    ;    
        nop              ;
        nop              ;
        nop              ;  = 0004h
        goto    int_dmx  ;    -  
;*************************************************************
TabSpeed: addwf PC,f ;  001- 250-
 dt  .001,.002,.003,.004,.005,.006,.007,.008
 dt  .010,.012,.015,.030,.050,.100,.150,.250
TabGobo:  addwf PC,f ;       GOBO
 dt  .000,.016,.028,.040,.052,.064,.076,.088 ;
 dt  .100,.112,.124,.136,.148,.160,.172,.184 ;
;*************************************************************
long_tab  equ  .215 ;    
TabComand: addwf PC,F ;  W-    210
; 21 - .,  22 - ., 23 - .
; 11 - ., 12 - .
; 4x,5x - CAP  -    . 
; 8x,9x - ROLL -  
; Ax,Bx -       
; Cx,Dx -       
; 01-  02-  03-  04-  05-
; 06- 07-   08- 09-  0-
; 0- 0-  0D-  0- 0F-
; 0-  0-                       0F-RossArt
;*************************************************************
; Version = ScanRain - 3 motor
;*************************************************************
;    :   0  31
    dt  0x00,0x07,0xbe,0xae,0xbe,0xae,0xbe,0xae ;
    dt  0x12,0xbe,0xae,0xbe,0xae,0xbe,0xae,0xbe ;
    dt  0x0a,0xce,0xde,0xce,0xde,0xce,0xde,0xce ;
    dt  0x0f,0xde,0xce,0xde,0xce,0xde,0xce,0xde ;
;    :   32  63
    dt  0x0E,0x0D,0x0C,0x0B,0x0A,0x09,0x08,0x07 ;
    dt  0x97,0x05,0x04,0x03,0x02,0x06,0x4F,0x41 ;
    dt  0x5f,0x51,0x4F,0x41,0x5F,0x51,0x4F,0x41 ;
    dt  0x02,0x4f,0x5f,0x4f,0x5f,0x03,0x4f,0x5F ;
;    :   64  95
    dt  0x4F,0x5f,0x04,0x4f,0x5F,0x4f,0x5f,0x05 ;
    dt  0x4F,0x5f,0x4f,0x5e,0x08,0x4e,0x85,0x5e ;
    dt  0x95,0x4e,0x85,0x09,0x5e,0x95,0x4e,0x85 ;
    dt  0x5e,0x95,0x4e,0x85,0x5e,0x95,0x42,0x11 ;
; 01-  02-  03-  04-  05-
; 06- 07-   08- 09-  0-
; 0- 0-  0-  0- 0F-
;    :   96  127
    dt  0x5f,0xaa,0xba,0xaa,0xba,0xaa,0xba,0xaa ; --
    dt  0x0d,0xce,0xde,0xce,0xde,0xce,0xde,0xce ;
    dt  0x0c,0xde,0xce,0xde,0xce,0xde,0xce,0xde ;
    dt  0x0b,0xbe,0xae,0xbe,0xae,0xbe,0xae,0xbe ;
;    :   128  159
    dt  0x0a,0x8e,0x9e,0x8e,0x9e,0x8e,0x9e,0x87 ;  --
    dt  0x12,0x5f,0x4f,0x5f,0x4f,0x5f,0x4f,0x5f ;
    dt  0x06,0x4f,0x5f,0x4f,0x5f,0x4f,0x5f,0x47 ;
    dt  0x05,0x9e,0x8e,0x9e,0x8e,0x9e,0x8e,0x9c ;
;    :   160  191
    dt  0x04,0x4e,0x5e,0x4e,0x5e,0x4e,0x5e,0x4e ;
    dt  0x03,0x5f,0x4f,0x5f,0x4f,0x5f,0x4f,0x5f ;
    dt  0x02,0x8e,0x9e,0x8e,0x9e,0x8e,0x9e,0x8e ;
    dt  0x01,0x5f,0x4f,0x5f,0x4f,0x5f,0x4f,0x5f ;
;    :   192  216
    dt  0x12,0x57,0x95,0x51,0x85,0x47,0x9e,0x8e ;
    dt  0x07,0x5e,0x0a,0x4e,0x0c,0x5e,0x0e,0x4e ;
    dt  0x01,0x5f,0x4f,0x5f,0x4f,0x85,0x00,0x00 ;
;***********************************************************************
        ORG    100H                 ;  
;***********************************************************************
Start:                              ; Main Programm
            bsf         STATUS,RP0  ; c 1
            movlw       b'00011111' ; A0-4 =in
            movwf       TRISA       ; A5  = out
            movlw       b'11111111' ; B0-B7 - inputs
            movwf       TRISB       ; DMX address
            movlw       b'10000000' ; C0-C6-out stepmotor
            movwf       TRISC       ; C7=RX,C6=TX
            movlw       b'00000000' ; 1:2-HS->Presc->Tmr0,
            movwf       OPTIONR     ;   :50 !!!
            movlw       b'00000100' ;  A2,4,5
            movwf       ADCON1      ; analog A0,1,3
            movlw       b'00100000' ;  
            movwf       PIE1        ; USART
            movlw       d'000'      ; =0, brg=0
            movwf       SPBRG       ; USART
            movlw       b'00100010' ;  BRGH =1 high
            movwf       TXSTA       ; USART      bit2 =0 low
            bcf         STATUS,RP0  ; c 0
;*************************************************************
            movlw       b'10011101' ;  
            movwf       ADCON0      ; ADC
            movlw       b'10010000' ;  
            movwf       RCSTA       ; USART
            movlw       b'00000000' ; (bit 5 = 0   data
            movwf       PIR1        ; USART -  !!!
            movlw       b'11000000' ;  
            movwf       INTCON      ; 
            movlw       b'00001100' ; mode  1
            movwf       CCP1CON     ; adr 17h
            movlw       b'00001100' ; mode  2
            movwf       CCP2CON     ; adr 1dh
            movlw       .063         ;   - 8 
            movwf       PR2         ; 63 = 39  (F=10Mhz)
            movlw       b'00000100' ;  2 - = 1:1
            movwf       T2CON       ; - = 1:1
;------------------------------------------------------------
        movlw   0x20       ; 
        movwf   FSR        ; 
clear_mem:                 ;
        clrf    INDF       ; 
        incf    FSR,f      ; ..   
        cpi     FSR,0x7F   ;  = 0
        jnz     clear_mem  ;
        clrwdt             ;  WDT 
;-------------------------------------------------------------
        clrf PORTA         ; . 
        call InitGobo      ; c Gobo   
;-------------------------------------------------------------
        mvi  GoboSunrise,.10  ;   Shim   GOBO
        clrf MestoGobo        ; c  = 0- 
        mvi  first,1          ; 1-  DMX
        mvi  LevelBright,.050 ;
        mvi  AdrTab,0xff      ;    !!!
;-------------------------------------------------------------
        mvi  dmx_1,.100    ;  -
        mvi  dmx_2,.20     ; gobo open
        mvi  dmx_3,.152    ;    
        mvi  dmx_4,.152    ;  
;*************************************************************
BaseCarryCuc: ; --      -----
;*************************************************************
        clrwdt             ;  WDT 
        btfss    TMR0,6    ; -6-   50  !!!
        goto    NoPlus     ;  6=0 -> 
        clrf     TMR0      ;  6=1 ->  
        incf    CountUniv,f;  , Program
        jnz     noCountU   ;     
        incf    CountProg,f;     | 
        incf    CountPosl,f;   |  
noCountU:                  ;                |   
        incf    Rollcount,f;  
        incf    Capcount,f ;
        incf    Gobocount,f;   Low=0
;-------------------------------------------------
        bcf     Lampa      ;  
        btfss   faza50     ;   = 0
        clrf    Faza       ;  
        btfss   faza50     ;   = 0
        goto    NoPlus     ; 
        decf    Faza,f     ;  
        cmp     Faza,FazaBright ;  
        jnz     NoPlus      ;    
        bsf     Lampa       ;  
NoPlus:
;-------------------------------------------------
        call    GoboMove    ;  Gobo ( )
        call    RollerMove  ;   ( )
        call    CapMove     ;   ( )
;-------------------------------------------------
        incf    Divider,f     ; 
        movlw   0x0f          ;   
        andwf   Divider,w     ;  
        jnz     BaseCarryCuc  ;   
;-------------------------------------------------
        cpi     Divider,0x00  ;  
        jz      CheckRoller   ;   
        cpi     Divider,0x30  ;  
        jz      CheckCap      ;    
        cpi     Divider,0x60  ;  
        jz      CheckSwith    ;  
        cpi     Divider,0x90  ;   
        jz      CheckGobo     ;
        cpi     Divider,0xC0  ;
        jz      CheckBright   ;
;---    ------------------------
        cpi     PORTB,0xff    ;     ?
        jnz     BaseCarryCuc  ; not
; ------      ---------------

        btfsc   Fweit        ;    
        goto    mus_gate     ;  =1,  
        cpi     CountProg,konst_m ;   
        jc      BaseCarryCuc ; ,      
        clrf    CountProg    ;   
        bsf     Fweit        ;   (=1)  
        goto    BaseCarryCuc ;   
mus_gate:
        btfss   Musik        ;   ?
        goto    BaseCarryCuc ;  
        bcf     Fweit        ; . -   
        call    FollowProg   ;    
        goto    BaseCarryCuc  ;   
;**********************************************************
CheckBright: ;     
;**********************************************************
       btfsc   ADCON0,2    ;   
       goto    BaseCarryCuc; =1,  
       btfss   Fadc        ;  : -hand
       goto    ToCheckStab ;  
       bcf     Fadc        ;  
       mov     HandBright,ADRES ;  
       comf    HandBright,f;    - 
       movlw   b'11001101' ;  ADC  = 3
       movwf   ADCON0      ;  =  2
       goto    BaseCarryCuc;   
ToCheckStab:
       bsf     Fadc        ;  
       mov     VoltBright,ADRES ;  . 
       movlw   b'11000101' ;  ADC  = 0
       movwf   ADCON0      ;  =  2
       goto    BaseCarryCuc;   
;**********************************************************
CheckGobo: ;    Gobo
;**********************************************************
         mov  TempGobo,MaskaGobo   ;   Gobo
         call GoboUstMode          ;
         cmp  MestoGobo,LevelGobo  ;  Gobo  
         jz   BaseCarryCuc         ;  
         cpi  LevelGobo,.250       ;   250
         jc   BaseCarryCuc         ;   
        mvi     GoboSunrise,.10   ;   Shim   GOBO
        goto    BaseCarryCuc      ;   

        cmp  MestoGobo,LevelGobo   ;   -
        jnc   MestoIsMore           ;   
        mov     TempForAll,MestoGobo ; Level - Mesto = Temp
        movf    LevelGobo,w          ;
        subwf   TempForAll,w         ;
        goto    UstSpeedGobo         ;
MestoIsMore:                         ;  
        mov     TempForAll,MestoGobo ; Mesto - Level = Temp
        movf    LevelGobo,w          ;
        subwf   TempForAll,w         ;
UstSpeedGobo:
        mvi     GoboSunrise,10    ;   Shim   GOBO
        cpi     TempForAll,.25    ; 15   
        jc      BaseCarryCuc      ;  
        cpi     TempForAll,.10    ;   
        jc      GoboSpeed1        ; 
        cpi     TempForAll,.05    ;   
        jc      GoboSpeed2        ; 
        mvi     GoboSunrise,1     ;   Shim   GOBO
        goto    BaseCarryCuc      ;   
GoboSpeed1:
        mvi     GoboSunrise,.01   ; 07   Shim   GOBO
        goto    BaseCarryCuc      ;   
GoboSpeed2:
        mvi     GoboSunrise,.01   ; 03   Shim   GOBO
        goto    BaseCarryCuc      ;   
;**********************************************************
CheckSwith:  ;   
;**********************************************************
;               goto    ModeProgram
;               goto    ModeMusik
         cpi     PORTB,0xff        ;     ?
         jz      ModeMusik         ;
         cpi     PORTB,0           ;    ?
         jz      ModeProgram       ;
        comf    PORTB,w           ;   
        movwf     first           ;   DMX
        mov     MaskaGobo,dmx_2   ;
        mov     LevelCap,dmx_3    ; 
        mov     LevelRoller,dmx_4 ;  
        cmp     HandBright,dmx_1  ;   Hand
        jc      ToHandUst         ; , 
        mov     LevelBright,dmx_1 ;   
        goto    ToStabUst         ; k  
ToHandUst:                        ;   
        mov     LevelBright,HandBright ;  
ToStabUst:                        ;  
         call    Stabilizator     ;
         goto    BaseCarryCuc     ;   
;**********************************************************
ModeMusik:      ;     
;**********************************************************
        mov     TempGobo,MaskaGobo ;   Gobo
        call    GoboUstMode        ;
        mov     LevelBright,HandBright ;  
        call    Stabilizator       ; lamp
        call    Posle         ;   10  
;       mov     LevelBright,HandBright ;  
        goto    BaseCarryCuc ;   
;**********************************************************
ModeProgram:   ;  
;**********************************************************
        mov     TempGobo,MaskaGobo ;   Gobo
        call    GoboUstMode        ;
        mov     LevelBright,HandBright ;  
        call    Stabilizator           ; lamp
        cpi     CountProg,konst_r;    
        jnz     BaseCarryCuc     ;     
        clrf    CountProg        ; , o 
        call    FollowProg       ;  
        goto    BaseCarryCuc     ;   
;**********************************************************
CheckCap: ;   
;**********************************************************
        bcf     FStopCap      ;  STOP
        cpi     LevelCap,.124 ;  121  134 
        jc      job_C         ; <124  
        cpi     LevelCap,.131 ;
        jc      BaseCarryCuc  ;  
job_C:                        ; >131  
        bsf     FStopCap      ;  
        mov     SpeedCap,LevelCap
        btfsc   LevelCap,7    ;   > 127 
        comf    SpeedCap,f    ;  
        rrf     SpeedCap,f    ;
        rrf     SpeedCap,f    ;
        rrf     SpeedCap,f    ;
        movlw   0x0f          ;
        andwf   SpeedCap,w    ; 
        call    TabSpeed      ;   
        movwf   SpeedCap      ;  
        goto    BaseCarryCuc  ;   
;**********************************************************
CheckRoller: ;     
;**********************************************************
        bcf     FStopRoller      ;  STOP
        cpi     LevelRoller,.124 ;  121  134 
        jc      job_R            ; <124  
        cpi     LevelRoller,.131 ;
        jc      BaseCarryCuc     ;  
job_R:                           ; >131  
        bsf     FStopRoller      ;  
        mov     SpeedRoller,LevelRoller
        btfsc   LevelRoller,7    ;   > 127 
        comf    SpeedRoller,f    ;  
        rrf     SpeedRoller,f    ;  
        rrf     SpeedRoller,f    ;
        rrf     SpeedRoller,f    ;
        movlw   0x0f             ;
        andwf   SpeedRoller,w    ;  Rollera
        call    TabSpeed         ;   
        movwf   SpeedRoller      ;   Rollera
        goto    BaseCarryCuc     ;   
;**************************************************************
FollowProg:  ;    
;**************************************************************
        clrf    PCLATH          ;
        incf    AdrTab,f        ;  
        cpi     AdrTab,long_tab ;   
        jnz     foll_obx        ;   arg = const
        clrf    AdrTab          ;    = 0
foll_obx:
        movf    AdrTab,w        ;   -> W
        call    TabComand       ;  
        movwf   DataTab         ;  
;==========   ==================================
        movwf   DataTemp        ;   
        movlw   b'11100000'     ;
        andwf   DataTemp,f      ;
        cpi     DataTab,0x30    ;   
        jc      AnalizGobo      ;     
;==========================================================
; 4x,5x - 4  CAP  -    . 
; 8x,9x - 8  ROLL -  
; Ax,Bx - 10       
; Cx,Dx - 12       
        cpi     DataTemp,b'01000000' ; 40h   
        jz      AnalizCap            ;      
        cpi     DataTemp,b'10000000' ; 80h
        jz      AnalizRoller         ;
        cpi     DataTemp,b'10100000' ; A0h
        jz      AnalizTogethe        ;
;-----------------------------------------------------------------------
        call    AnalizCap            ;   
        movlw   b'00010000'
        xorwf   DataTab,f            ;  
        goto    AnalizRoller         ;
;-----------------------------------------------------------------------
AnalizTogethe:                       ;   
        call    AnalizCap            ;
        goto    AnalizRoller         ;
;-----------------------------------------------------------------------
AnalizGobo:  ;  =(16 )+(050-)+(060-)
         cpi     DataTab,0x11      ;  
         jz      AnalizRainBow1    ;
         cpi     DataTab,0x12      ;  
         jz      AnalizRainBow2    ;
         cpi     DataTab,0x21      ; strob  
         jz      AnalizStrob1      ;
         cpi     DataTab,0x22      ; strob  
         jz      AnalizStrob2      ;
         cpi     DataTab,0x23      ; strob  
         jz      AnalizStrob3      ;
         mov     MaskaGobo,DataTab ;
         swapf   MaskaGobo,f       ;
         movlw   0xF0              ;
         andwf   MaskaGobo,f       ;
         incf    MaskaGobo,f       ; -------!!!--------------
         return                    ;    
;-----------------------------------------------------------------------
AnalizRainBow2:
         mvi     MaskaGobo,.255    ;    
         return
AnalizRainBow1:
         mvi     MaskaGobo,.254    ;    
         return
AnalizStrob3:
         mvi     MaskaGobo,.253    ;  
         return
AnalizStrob2:
         mvi     MaskaGobo,.252    ;  
         return
AnalizStrob1:
         mvi     MaskaGobo,.251    ;  
         return
;-----------------------------------------------------------------------
AnalizRoller:   ;  = + 4=
         mov     DataTemp,DataTab  ;
         btfss   DataTemp,4        ;   = 0
         call    invers            ;
         rlf     DataTemp,f        ;  32 
         rlf     DataTemp,f        ;   - 16 
         rlf     DataTemp,f        ;  
         movlw   b'11111000'       ;
         andwf   DataTemp,f        ;
         mov     LevelRoller,DataTemp ;  
         return                       ;  
;-----------------------------------------------------------------------
AnalizCap: ; 40h  = + 4=
         mov     DataTemp,DataTab  ;
         btfss   DataTemp,4        ;   = 0
         call    invers            ;
         rlf     DataTemp,f        ;  32 
         rlf     DataTemp,f        ;   - 16 
         rlf     DataTemp,f        ;  
         movlw   b'11111000'       ;
         andwf   DataTemp,f        ;
         mov     LevelCap,DataTemp ;   
         return
invers:
         comf    DataTemp,f        ; 
         nop
         bcf     DataTemp,4        ; 
         return
;***********************************************************************
Posle:        ;    3 
;***********************************************************************
        btfss   Musik          ;   
        goto    posl_nogate    ;    ?
        clrf    CountPosl      ;   
        clrf    CountPosh      ;   
        cpi     MaskaGobo,0    ;
        rnz
        mvi     MaskaGobo,.248 ;   
        return
posl_nogate:                   ;  
        cpi     CountPosl,.250 ;    
        rnz                    ; ret,      
        cpi     LevelBright,.30;  
        jc      posl_dark      ;
        movlw   .03            ;
        subwf   LevelBright,f  ;
posl_dark:
        incf    CountPosh,f    ;
        cpi     CountPosh,konst_;  3 
        jnz     posl_noCap       ;
        mvi     LevelCap,.130    ; STOP 
        mvi     LevelRoller,.130 ; STOP  
;       mvi     MaskaGobo,.20    ; open 
;       mvi     LevelBright,090  ;
posl_noCap:
        cpi     CountPosh,konst_p;  15 
        rnz                      ;      
        clrf    CountPosl        ;   
        clrf    MaskaGobo        ;  ,  
        return
;**************************************************************
        ORG     300h           ;  PCLATH = 300h
;**************************************************************
;      -  
;**************************************************************
int_dmx:                       ;
        movwf   temp_w         ;  W
        swapf   STATUS,w       ;  Status
        bcf     STATUS,RP0     ;  0
        movwf   temp_s         ; c  PUSH
;---------     !!! ------------------
        movf    FSR,w          ;  fsr
        movwf   temp_fsr       ;
;-------   -------------------------------------
        btfsc   RCSTA,2        ;  -  STOP-BIT
        goto    int_gate       ;   
        btfsc   flag_0         ;    
        goto    int_wait00     ;     =00=
        btfsc   flag_1         ;
        goto    int_reciv      ;   
        btfsc   flag_2         ;
        goto    int_write      ;   
        clrf    Flagsdmx       ;  
        mov     rx,RCREG       ;   
        goto    ret_int        ;   
;---------------------------------------------------------------
int_wait00:                    ;   =00=
        mov     rx,RCREG       ;   
        mvi     tekuch,1       ;  
        cpi     rx,0x00        ;   =00=  
        jnz     ret_int        ;    
        bcf     flag_0         ;   
        bsf     flag_1         ; .  
        goto    ret_int        ;  =00=   
;---------------------------------------------------------------
int_reciv:                     ;    
        bcf     flag_0         ;   
        bsf     flag_1         ; .  
        mvi     channel,1      ;  
        cmp     tekuch,first   ;    
        jz      int_write      ;    
        mov     rx,RCREG       ;   
        incf    tekuch,f       ;   DMX
        goto    ret_int        ;   
;---------------------------------------------------------------
int_write:
        bcf     flag_1         ; c  
        bsf     flag_2         ; .  
        mvi     FSR,dmx_0      ; 
        movf    channel,w      ;   
        addwf   FSR,f          ;  
        mov     INDF,RCREG     ;   
        incf    channel,f      ;  
        cpi     channel,.7     ;  
        jnz     ret_int        ;    
        clrf    Flagsdmx       ; c  - 
        goto    ret_int        ;   
;---------------------------------------------------------------
int_gate:        ;    DMX
        bsf     flag_0         ; .  
        mov     rx,RCREG       ;   
ret_int:
        bcf     PIR1,5         ; USART -  !!!
        movf    temp_fsr,w     ;
        movwf   FSR            ; return fsr
        swapf   temp_s,w       ; c  POP
        movwf   STATUS         ;  Status
        swapf   temp_w,f       ;  W 
        swapf   temp_w,w       ;   Z !
        retfie      ;       
;************************************************************
GoboMove: ; Gobo =    
;************************************************************
        cmp  MestoGobo,LevelGobo ;  Gobo  
        rz                       ;  
        cpi  Gobocount,.010      ;    
        btfsc   STATUS,CR   ;     
        return              ;  
        clrf    Gobocount   ;   
        mvi     PCLATH,3    ;     
        cmp  MestoGobo,LevelGobo  ;   
        jc   GoboLeft             ;   
; --------      -----------------
        movf    Shimswith,w ;   
        addwf   PC,f        ;    
        goto    decShim1    ;
        goto    decShim2    ;
        goto    decShim3    ;
        goto    decShim4    ;
newSwithR:
        decf    MestoGobo,f ;    = 1 
        decf    Shimswith,f ;     
        movlw   b'00000011' ; (   )
        andwf   Shimswith,f ;   
        return
;-------------------------------------------------------------
decShim1:
        cpi     CCPR1L,.240 ;   , 
        jnc   newSwithR     ;   
        movf  GoboSunrise,w ;    SUNRISE  
        addwf   CCPR1L,f    ;    
        return              ;    
;-------------------------------------------------------------
decShim2:
        cpi     CCPR2L,.016 ;   , 
        jc    newSwithR     ;   
        movf  GoboSunrise,w ;    SUNRISE  
        subwf   CCPR2L,f    ;    
        return              ;    
;-------------------------------------------------------------
decShim3:
        cpi     CCPR1L,.016 ;   , 
        jc    newSwithR     ;   
        movf  GoboSunrise,w ;    SUNRISE  
        subwf   CCPR1L,f    ;    
        return              ;    
;-------------------------------------------------------------
decShim4:
        cpi     CCPR2L,.240 ;   , 
        jnc   newSwithR     ;   
        movf  GoboSunrise,w ;    SUNRISE  
        addwf   CCPR2L,f    ;    
        return              ;    
;-------------------------------------------------------------
GoboLeft: ; Gobo =     
;-------------------------------------------------------------
        movf    Shimswith,w ;   
        addwf   PC,f        ;    
        goto    incShim1    ;
        goto    incShim2    ;
        goto    incShim3    ;
        goto    incShim4    ;
newSwithL:
        incf    MestoGobo,f ;    = 1 
        incf    Shimswith,f ;     
        movlw   b'00000011' ; (   )
        andwf   Shimswith,f ;   
        return
;-------------------------------------------------------------
incShim1:
        cpi     CCPR1L,.016 ;   , 
        jc    newSwithL     ;   
        movf  GoboSunrise,w ;    SUNRISE  
        subwf   CCPR1L,f    ;    
        return              ;    
;-------------------------------------------------------------
incShim2:
        cpi     CCPR2L,.240 ;   , 
        jnc   newSwithL     ;   
        movf  GoboSunrise,w ;    SUNRISE  
        addwf   CCPR2L,f    ;    
        return              ;    
;-------------------------------------------------------------
incShim3:
        cpi     CCPR1L,.240 ;   , 
        jnc   newSwithL     ;   
        movf  GoboSunrise,w ;    SUNRISE  
        addwf   CCPR1L,f    ;    
        return              ;    
;-------------------------------------------------------------
incShim4:
        cpi     CCPR2L,.016 ;   , 
        jc    newSwithL     ;   
        movf  GoboSunrise,w ;    SUNRISE  
        subwf   CCPR2L,f    ;    
        return              ;    
;**************************************************************
Stabilizator:     ;
;**************************************************************
         cpi     LevelGobo,1
         jz      MinBright
         cpi     LevelGobo,0
         jz      MinBright
         cpi     VoltBright,konst_mains+20
         jnc     menee25
         cpi     VoltBright,konst_mains+15
         jnc     menee20
         cpi     VoltBright,konst_mains+10
         jnc     menee15
         cpi     VoltBright,konst_mains+5
         jnc     menee10
         cpi     VoltBright,konst_mains
         jnc     menee05
         goto    OutBright         ;
menee25:
         movlw   .75
         goto    MMXbright         ;  
menee20:
         movlw   .60
         goto    MMXbright         ;  
menee15:
         movlw   .45
         goto    MMXbright         ;  
menee10:
         movlw   .30
         goto    MMXbright         ;  
menee05:
         movlw   .15
         goto    MMXbright         ;  
;-------------------------------------------------------------
MMXbright:
         subwf   LevelBright,f     ;
         jc      OutBright         ;
         goto    MinBright         ;
OutBright:
        mov     FazaBright,LevelBright ;
        cpi     FazaBright,konst_dark  ;   
        rc                             ; 
MinBright:
        mvi     FazaBright,konst_dark  ;
        return
;**************************************************************
GoboUstMode: ;  TempGobo -> LevelGobo
;**************************************************************
        cpi     TempGobo,0        ;   = 0
        jz      CloseGobo         ;    
        cpi     TempGobo,.015     ;   15 
        jc      OpeningGobo       ;   
        cpi     TempGobo,.250     ;   250
        jnc     StrobRainBow      ;   
        mvi     GoboSunrise,10    ;   Shim   GOBO
        swapf   TempGobo,f        ;  16 
        movlw   0x0F              ;
        andwf   TempGobo,w        ;
        clrf    PCLATH            ;
        call    TabGobo           ;   
        movwf   LevelGobo         ;   
   cpi     LevelGobo,0
   jz      NoZeroGobo
   cpi     LevelGobo,1
   jz      NoZeroGobo
        return                    ;    
NoZeroGobo:
        mvi     LevelGobo,2
        return                    ;    
OpeningGobo:   ;     
        mvi     GoboSunrise,1     ;   Shim   GOBO
        mov     LevelGobo,TempGobo; Gobo
        return                    ;    
CloseGobo:     ;    
        cpi     MestoGobo,10
        jc      NoSpeedGobo
        mvi     GoboSunrise,10    ;   Shim   GOBO
NoSpeedGobo:
        mov     LevelGobo,TempGobo; Gobo
        cpi     LevelGobo,0 ;     = 0
        rnz                 ;    
        cpi     MestoGobo,0 ;     = 0
        rnz                 ;    
        mvi  GoboSunrise,1  ; 1    Shim   GOBO
        mvi  LevelGobo,0    ; 0      
        mvi  MestoGobo,.1   ; 1
        return                    ;    
;**************************************************************
StrobRainBow: ;
        cpi     TempGobo,.255     ;
        jz      RainBowGoboFast   ;    
;    cpi     MestoGobo,.74     ;    
;    jnc     RainBowSpeed      ;    
        cpi     TempGobo,.254     ;
        jz      RainBowGoboMedl   ;    
;    cpi     MestoGobo,.25     ;   
;    jnc     RainBowSpeed      ;   
        cpi     TempGobo,.253     ;
        jz      Strob1            ; strob 
        cpi     TempGobo,.252     ;
        jz      Strob2            ; strob 
        goto    Strob3            ;  
;--------------------------------------------------------------
RainBowSpeed:                     ;    
        mvi     GoboSunrise,9     ;   Shim   GOBO
        return                    ;    
;--------------------------------------------------------------
RainBowGoboMedl:     ;      
        mvi     GoboSunrise,3     ;   Shim   GOBO
        cpi     MestoGobo,.62     ;     
        jnc     RainBowGateMedl   ;  
        cpi     MestoGobo,.15     ;    
        jnc     RainBowFastMedl   ; 
RainBowGateMedl:
        mvi     GoboSunrise,1     ;   Shim   GOBO
RainBowFastMedl:
        cpi     LevelGobo,.12     ;
        jz      Rainbow17         ;
        cpi     LevelGobo,.67     ;
        jz      Rainbow67         ;
        mvi     LevelGobo,.12     ;
        return                    ;    
Rainbow67:
        cpi     MestoGobo,.67     ;
        rnz                       ;
        mvi     LevelGobo,.12     ;
        return                    ;    
Rainbow17:
        cpi     MestoGobo,.12     ;
        rnz                       ;
        mvi     LevelGobo,.67     ;
        return                    ;    
;--------------------------------------------------------------
RainBowGoboFast:     ;     
        mvi     GoboSunrise,9     ;   Shim   GOBO
        cpi     MestoGobo,.182    ;     
        jnc     RainBowGateFast   ;  
        cpi     MestoGobo,.17     ;    
        jnc     RainBowFastFast   ; 
RainBowGateFast:
        mvi     GoboSunrise,1     ;   Shim   GOBO
RainBowFastFast:
        cpi     LevelGobo,.15     ;
        jz      Rainbow18         ;
        cpi     LevelGobo,.184    ; 184
        jz      Rainbow184        ;
        mvi     LevelGobo,.15     ;
        return                    ;    
Rainbow184:
        cpi     MestoGobo,.184    ; 184
        rnz                       ;
        mvi     LevelGobo,.15     ;
        return                    ;    
Rainbow18:
        cpi     MestoGobo,.15     ;
        rnz                       ;
        mvi     LevelGobo,.184    ;
        return                    ;    
;--------------------------------------------------------------
Strob1:                           ;  
        mvi     GoboSunrise,10    ;   Shim   GOBO
        cpi     MestoGobo,.19     ;     
        jnc     StrobGate         ;  
        cpi     MestoGobo,.3      ; 2--    
        jnc     StrobFast         ;  
        goto    StrobGate         ;
Strob2:                           ;  
        mvi     GoboSunrise,09    ;   Shim   GOBO
        cpi     MestoGobo,.19     ;     
        jnc     StrobGate         ;  
        cpi     MestoGobo,.4      ; 3--    
        jnc     StrobFast         ;  
        goto    StrobGate         ;
Strob3:                           ;  
        mvi     GoboSunrise,10    ;   Shim   GOBO
        cpi     MestoGobo,.19     ;     
        jnc     StrobGate         ;  
        cpi     MestoGobo,.6      ;    
        jnc     StrobFast         ;  
StrobGate:
        mvi     GoboSunrise,1     ;   Shim   GOBO
StrobFast:
        cpi     LevelGobo,.20     ;
        jz      StrobMove20       ;
        cpi     LevelGobo,.02     ; 01---
        jz      StrobMove01       ;
        mvi     LevelGobo,.02     ; 01---
        return                    ;    
StrobMove20:       ;
        cpi     MestoGobo,.20     ;
        rnz                       ;
        mvi     LevelGobo,.02     ; 01---
        return                    ;    
StrobMove01:       ;
        cpi     MestoGobo,.02     ; 01-----
        rnz                       ;
        mvi     LevelGobo,.20     ;
        return                    ;    
;************************************************************
        ORG     500h
;************************************************************
CapMove:  ;   =  
;************************************************************
        btfss   FStopCap    ;   
        return              ;  
        btfsc   LevelCap,7  ;  
        goto    CapLeft     ; 
        movf    SpeedCap,w  ;  : c
        subwf   Capcount,w  ;   
        btfss   STATUS,CR   ;   
        goto    cross_C1    ; ,  
        clrf    Capcount    ;   
        incf    Capstep,f   ;   
        jnz     cross_C1    ;   = 0  
        decf    Capswith,f  ;     
        movlw   b'00000011' ; (   )
        andwf   Capswith,f  ;   
cross_C1:                   ;
        decf    CapSqw,f    ;  
        mvi     PCLATH,5    ; org 500h
        movf    Capswith,w  ;  
        addwf   PC,f
        goto    Cap1varR4   ; 4
        goto    Cap1varR3   ; 3
        goto    Cap1varR2   ; 2
        goto    Cap1varR1   ; 1
;-------------------------------------------------------------
Cap1varR1: ;     
        cmp     CapSqw,Capstep  ;   
        btfsc   STATUS,0        ;
        goto    cst100010       ;   - 1->0
        goto    cst100100       ;   - 0->1
;-------------------------------------------------------------
Cap1varR2: ;     
        cmp     CapSqw,Capstep  ;   
        btfsc   STATUS,0
        goto    cst010010       ;   - 1->0
        goto    cst100010       ;   - 0->1
;-------------------------------------------------------------
Cap1varR3: ;     
        cmp     CapSqw,Capstep  ;   
        btfsc   STATUS,0
        goto    cst010100       ;   - 1->0
        goto    cst010010       ;   - 0->1
;-------------------------------------------------------------
Cap1varR4: ;     
        cmp     CapSqw,Capstep  ;   
        btfsc   STATUS,0
        goto    cst100100       ;   - 1->0
        goto    cst010100       ;   - 0->1
;-------------------------------------------------------------
CapLeft:  ;   =   ()
;-------------------------------------------------------------
        movf    SpeedCap,w
        subwf   Capcount,w  ;   
        btfss   STATUS,CR   ;   
        goto    cross_k1    ; ,  
        clrf    Capcount    ;   
        incf    Capstep,f   ;   
        jnz     cross_k1    ;   = 0  
        incf    Capswith,f  ; ???    
        movlw   b'00000011' ; (   )
        andwf   Capswith,f  ;   
cross_k1:                   ;
        incf    CapSqw,f    ;  
        mvi     PCLATH,5    ; org 500h
        movf    Capswith,w  ;
        addwf   PC,f
        goto    Cap1varL4   ;
        goto    Cap1varL3   ;
        goto    Cap1varL2   ;
        goto    Cap1varL1   ;
;-------------------------------------------------------------
Cap1varL1: ;     
        cmp     CapSqw,Capstep ;   
        btfss   STATUS,0        ;
        goto    cst100010       ;   - 1->0
        goto    cst100100       ;   - 0->1
;-------------------------------------------------------------
Cap1varL2: ;     
        cmp     CapSqw,Capstep ;   
        btfss   STATUS,0
        goto    cst010010       ;   - 1->0
        goto    cst100010       ;   - 0->1
;-------------------------------------------------------------
Cap1varL3: ;     
        cmp     CapSqw,Capstep ;   
        btfss   STATUS,0
        goto    cst010100       ;   - 1->0
        goto    cst010010       ;   - 0->1
;-------------------------------------------------------------
Cap1varL4: ;     
        cmp     CapSqw,Capstep ;   
        btfss   STATUS,0
        goto    cst100100       ;   - 1->0
        goto    cst010100       ;   - 0->1
;-------------------------------------------------------------
cst100010:           ; 1
     bsf  CapA       ;    =A= 
     bcf  CapB       ;    =B= 
     clrf PCLATH
     return          ;
cst100100:           ; 2
     bsf  CapA       ;    =A= 
     bsf  CapB       ;    =B= 
     clrf PCLATH
     return          ;
cst010010:           ; 3
     bcf  CapA       ;    =A= 
     bcf  CapB       ;    =B= 
     clrf PCLATH
     return          ;
cst010100:           ; 4
     bcf  CapA       ;    =A= 
     bsf  CapB       ;    =B= 
     clrf PCLATH
     return          ;
;************************************************************
RollerMove:  ;   =  
;************************************************************
        btfss   FStopRoller ;   
        return              ;  
        btfss   LevelRoller,7 ;  
        goto    RollerLeft    ; 
        movf    SpeedRoller,w ;  : c
        subwf   Rollcount,w ;   
        btfss   STATUS,CR   ;   
        goto    cross_r1    ; ,  
        clrf    Rollcount   ;   
        incf    Rollstep,f  ;   
        jnz     cross_r1    ;   = 0  
        decf    Rollswith,f ;     
        movlw   b'00000011' ; (   )
        andwf   Rollswith,f ;   
cross_r1:                   ;
        decf    RollSqw,f   ;  
        mvi     PCLATH,5    ; org 500h
        movf    Rollswith,w ;  
        addwf   PC,f
        goto    Roll1varR4   ; 4
        goto    Roll1varR3   ; 3
        goto    Roll1varR2   ; 2
        goto    Roll1varR1   ; 1
;-------------------------------------------------------------
Roll1varR1: ;     
        cmp     RollSqw,Rollstep;   
        btfsc   STATUS,0        ;
        goto    ust100010       ;   - 1->0
        goto    ust100100       ;   - 0->1
;-------------------------------------------------------------
Roll1varR2: ;     
        cmp     RollSqw,Rollstep;   
        btfsc   STATUS,0
        goto    ust010010       ;   - 1->0
        goto    ust100010       ;   - 0->1
;-------------------------------------------------------------
Roll1varR3: ;     
        cmp     RollSqw,Rollstep;   
        btfsc   STATUS,0
        goto    ust010100       ;   - 1->0
        goto    ust010010       ;   - 0->1
;-------------------------------------------------------------
Roll1varR4: ;     
        cmp     RollSqw,Rollstep;   
        btfsc   STATUS,0
        goto    ust100100       ;   - 1->0
        goto    ust010100       ;   - 0->1
;-------------------------------------------------------------
RollerLeft:  ;   =   ()
;-------------------------------------------------------------
        movf    SpeedRoller,w
        subwf   Rollcount,w ;   
        btfss   STATUS,CR   ;   
        goto    cross_l1    ; ,  
        clrf    Rollcount   ;   
        incf    Rollstep,f  ;   
        jnz     cross_l1    ;   = 0  
        incf    Rollswith,f ; ???    
        movlw   b'00000011' ; (   )
        andwf   Rollswith,f ;   
cross_l1:                   ;
        incf    RollSqw,f   ;  
        mvi     PCLATH,5    ; org 500h
        movf    Rollswith,w ;
        addwf   PC,f
        goto    Roll1varL4   ;
        goto    Roll1varL3   ;
        goto    Roll1varL2   ;
        goto    Roll1varL1   ;
;-------------------------------------------------------------
Roll1varL1: ;     
        cmp     RollSqw,Rollstep;   
        btfss   STATUS,0        ;
        goto    ust100010       ;   - 1->0
        goto    ust100100       ;   - 0->1
;-------------------------------------------------------------
Roll1varL2: ;     
        cmp     RollSqw,Rollstep;   
        btfss   STATUS,0
        goto    ust010010       ;   - 1->0
        goto    ust100010       ;   - 0->1
;-------------------------------------------------------------
Roll1varL3: ;     
        cmp     RollSqw,Rollstep;   
        btfss   STATUS,0
        goto    ust010100       ;   - 1->0
        goto    ust010010       ;   - 0->1
;-------------------------------------------------------------
Roll1varL4: ;     
        cmp     RollSqw,Rollstep;   
        btfss   STATUS,0
        goto    ust100100       ;   - 1->0
        goto    ust010100       ;   - 0->1
;-------------------------------------------------------------
ust100010:              ; 1
     bsf  RollerA       ;    =A= 
     bcf  RollerB       ;    =B= 
     clrf PCLATH
     return             ;
ust100100:              ; 2
     bsf  RollerA       ;    =A= 
     bsf  RollerB       ;    =B= 
     clrf PCLATH
     return             ;
ust010010:              ; 3
     bcf  RollerA       ;    =A= 
     bcf  RollerB       ;    =B= 
     clrf PCLATH
     return             ;
ust010100:              ; 4
     bcf  RollerA       ;    =A= 
     bsf  RollerB       ;    =B= 
     clrf PCLATH
     return             ;
;**************************************************************
InitGobo:                   ; c Gobo   
;**************************************************************
        mvi  GoboSunrise,.10; 2   Shim   GOBO
        clrf LevelGobo      ;     
        mvi  MestoGobo,.250 ;
InitGoboCucSpeed:           ; c Gobo   
        clrwdt              ;  WDT 
        btfss    TMR0,6     ; -6-   50  !!!
        goto    NoPlusInit  ;  6=0 -> 
        clrf     TMR0       ;  6=1 ->  
        incf    Gobocount,f ;   Low=0
NoPlusInit:
        call    GoboMove    ;  Gobo ( )
        cmp  MestoGobo,LevelGobo ;  Gobo  
        jnz  InitGoboCucSpeed
;----------------------------------------------------------
        mvi  GoboSunrise,1  ;   Shim   GOBO
        clrf LevelGobo      ;     
        mvi  MestoGobo,.20  ; 10
InitGoboCucLow:             ; c Gobo   
        clrwdt              ;  WDT 
        btfss    TMR0,6     ; -6-   50  !!!
        goto    NoLowsInit  ;  6=0 -> 
        clrf     TMR0       ;  6=1 ->  
        incf    Gobocount,f ;   Low=0
NoLowsInit:
        call    GoboMove    ;  Gobo ( )
        cmp  MestoGobo,LevelGobo ;  Gobo  
        jnz  InitGoboCucLow
;----------------------------------------------------------
        return              ;   -  
;**************************************************************
  End  ;    BrSoft Copyright (C) 2004 Bogdanov Andrew
;**************************************************************






