;*************************************************************
;  (DMX)    CENTRUM
;************************************************************
;   Filename:           carrydmx.asm
;   First Date:         15 januar  2004
;   File Version:       1.00
;   Assembler:          mpasm 1.40
;   Author:             Bogdanov Andrew
;   E-Mail:             Bogdanov@tsrv.ru
;************************************************************
;  LIST   p=16C73  ; cp=off=1. 3pwrt|on=1. 2wdt|on=1. =HS   *
 __CONFIG b'00000011000010'        ;   CP on      *
;__CONFIG b'11111111111110'        ;    CP off    *
;************************************************************
#include pic73.mac ;                                     *
;************************************************************
;           Bit Definitions                                 *
;************************************************************
#define  flag_0   Flagsdmx,0  ;                       *
#define  flag_1   Flagsdmx,1  ;                *
#define  flag_2   Flagsdmx,2  ;                  *
#define  flag_3   Flagsdmx,3  ;  DMX                 *
#define  flag_d   Flagsdmx,4  ; news                       *
;************************************************************
#define  Fweit         Flags1,1 ; a  .
#define  Freset        Flags1,2 ;   Switcher
;------------------------------------------------------------
#define  FStopCap1     Flags2,1 ; stop  
#define  FStopCap2     Flags2,2 ; stop  
#define  FStopCap3     Flags2,3 ; stop  
#define  FStopCap4     Flags2,4 ; stop  
;******************** Ports Bits ****************************
#define  Musik     PORTA,4     ;  
;-----------------------------------------------------------*
#define  Cap1A     PORTC,0  ;    1  =A=
#define  Cap1B     PORTC,3  ;    1  =B=
#define  Cap2A     PORTC,1  ;    2  =A=
#define  Cap2B     PORTC,2  ;    2  =B=
#define  Cap3A     PORTC,4  ;    3  =A=
#define  Cap3B     PORTC,5  ;    3  =B=
#define  Cap4A     PORTA,0  ;    4  =A=
#define  Cap4AI    PORTA,1  ;    4  =A= invers
#define  Cap4B     PORTA,2  ;    4  =B=
#define  Cap4BI    PORTA,3  ;    4  =B= invers
;************************************************************
;           Register Definitions  20h - 7fh
;******  Roller *************************************
Cap1step     equ   0x20  ;    
Cap1count    equ   0x21  ;   
Cap1swith    equ   0x22  ;   
Cap1Sqw      equ   0x23  ;    
LevelCap1    equ   0x24  ;  
SpeedCap1    equ   0x25  ; Speed  
;------------------------------------------------------------
Cap2step     equ   0x26  ;    
Cap2count    equ   0x27  ;   
Cap2swith    equ   0x28  ;   
Cap2Sqw      equ   0x29  ;    
LevelCap2    equ   0x2A  ;  
SpeedCap2    equ   0x2B  ; Speed  
;------------------------------------------------------------
Cap3step     equ   0x2C  ;    
Cap3count    equ   0x2D  ;   
Cap3swith    equ   0x2E  ;   
Cap3Sqw      equ   0x2F  ;    
LevelCap3    equ   0x30  ;  
SpeedCap3    equ   0x31  ; Speed  
;------------------------------------------------------------
Cap4step     equ   0x32  ;    
Cap4count    equ   0x33  ;   
Cap4swith    equ   0x34  ;   
Cap4Sqw      equ   0x35  ;    
LevelCap4    equ   0x36  ;  
SpeedCap4    equ   0x37  ; Speed  
;***************************************************************
Divider     equ   0x40   ; - .swith  
Flags1      equ   0x41   ; ,   
Flags2      equ   0x42   ; ,   
CountUniv   equ   0x43   ;   (+RTCC)
CountPosl   equ   0x44   ; (+RTCC)    LB
CountPosh   equ   0x45   ;     HB
CountProg   equ   0x46   ; (+RTCC)    "a"
DataTemp    equ   0x47   ;     
DataTab     equ   0x48   ;    
AdrTab      equ   0x49   ;   
TempForAll  equ   0x4A   ;
;*************************************************************
dmx_0       equ  0x50   ; 0- 
dmx_1       equ  0x51   ;  1
dmx_2       equ  0x52   ;  2
dmx_3       equ  0x53   ;  3
dmx_4       equ  0x54   ;  4
dmx_5       equ  0x55   ;
dmx_6       equ  0x56   ;  
dmx_7       equ  0x57   ;  
dmx_8       equ  0x58   ;
;*************    DMX *************************
Flagsdmx    equ   0x70  ; \   
temp_cnt    equ   0x71  ; \ Int    
temp_rx     equ   0x72  ; \ Int     
temp_s      equ   0x73  ; \ Int  
temp_w      equ   0x74  ; \
temp_fsr    equ   0x75  ; \ Int    
rx          equ   0x76  ;   DMX
mode_int    equ   0x77  ;    
first       equ   0x78  ;    
tekuch      equ   0x79  ;    
channel     equ   0x7A  ;    
;*************************************************************
konst_r    equ    d'035'   ;     
; p k30=time50sec ;r 75=120/ ;
konst_p     equ   d'033'  ; 15  .  off-lamp
konst_     equ   d'003'  ; 03  .  off-roll
konst_m     equ   d'050'  ; 37     
;*************************************************************
        ORG     0        ;  
;***********************************************************************
        goto    Start    ;    
        nop              ;
        nop              ;
        nop              ;  = 0004h
        goto    int_dmx  ;    -  
;*************************************************************
TabSpeed: addwf PC,f ;  001- 250-
 dt  .001,.002,.003,.004,.005,.006,.007,.008
 dt  .010,.012,.015,.030,.050,.100,.150,.250
;*************************************************************
long_tab  equ  .128 ;    
TabComand: addwf PC,F ;  W-    210
; 0x,1x-CAP1    2x,3x-CAP2   4x,5x - CAP3   6x,7x - CAP4
; Ax,Bx -       
;*************************************************************
; Version = CENTRUM - 4 motors
;*************************************************************
;    :   0  31
    dt  0xAF,0xBF,0xAF,0xBF,0xAF,0xBF,0xAF,0xB7 ;
    dt  0x0F,0x1F,0x0F,0x1F,0x0F,0x1F,0x0F,0xA7 ;
    dt  0x2F,0x3F,0x2F,0x3F,0x2F,0x3F,0x2F,0xB7 ;
    dt  0x4F,0x5F,0x4F,0x5F,0x4F,0x5F,0x4F,0xA7 ;
;    :   32  63
    dt  0x6F,0x7F,0x6F,0x7F,0x6F,0x7F,0x6F,0xBf ;
    dt  0x0B,0x2B,0x4B,0x6B,0xAB,0xBB,0xAC,0xAD ;
    dt  0xAF,0xBF,0xAF,0xBF,0xAF,0xBF,0xAF,0xB7 ;
    dt  0xAF,0xA1,0xBF,0xB1,0xAF,0xA1,0xBF,0xB1 ;
;    :   64  95
    dt  0x0F,0x01,0x1F,0x11,0x2F,0x21,0x3F,0x31 ;
    dt  0x4F,0x41,0x5F,0x51,0x6F,0x61,0x7F,0x71 ;
    dt  0xAA,0xBA,0xAA,0xBA,0xAA,0xBA,0xAA,0xBA ;
    dt  0xAF,0xBF,0xAF,0xBF,0xAF,0xBF,0xAF,0xB3 ;
;    :   96  127
    dt  0x0F,0x2F,0x4F,0x6F,0x1F,0x3F,0x5F,0x7F ;
    dt  0x0D,0x1D,0x2D,0x3D,0x4D,0x5D,0x6D,0x7D ;
    dt  0xAF,0xBF,0xAF,0xBF,0xAF,0xBF,0xAF,0xBF ;
    dt  0x05,0x25,0x45,0x65,0x7F,0x5F,0x3F,0x1F ;
;------------------------------------------------
;    :   128  159
    dt  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 ;
    dt  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 ;
    dt  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 ;
    dt  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 ;
;    :   160  191
    dt  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 ;
    dt  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 ;
    dt  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 ;
    dt  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 ;
;    :   192  220
    dt  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 ;
    dt  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 ;
    dt  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 ;
    dt  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 ;
;***********************************************************************
        ORG    100H                 ;  
;***********************************************************************
Start:                              ; Main Programm
            bsf         STATUS,RP0  ; c 1
            movlw       b'00110000' ; A4-5 = in
            movwf       TRISA       ; A0-3 = out
            movlw       b'11111111' ; B0-B7 - inputs
            movwf       TRISB       ; DMX address
            movlw       b'10000000' ; C0-C6-out stepmotor
            movwf       TRISC       ; C7=RX,C6=TX
            movlw       b'00000000' ; 1:2-HS->Presc->Tmr0,
            movwf       OPTIONR     ;   :50 !!!
            movlw       b'00000111' ; 
            movwf       ADCON1      ;
            movlw       b'00100000' ;  
            movwf       PIE1        ; USART
            movlw       d'000'      ; =0, brg=0
            movwf       SPBRG       ; USART
            movlw       b'00100010' ;  BRGH =1 high
            movwf       TXSTA       ; USART      bit2 =0 low
            bcf         STATUS,RP0  ; c 0
;*************************************************************
            movlw       b'10010000' ;  
            movwf       RCSTA       ; USART
            movlw       b'00000000' ; (bit 5 = 0   data
            movwf       PIR1        ; USART -  !!!
            movlw       b'11000000' ;  
            movwf       INTCON      ; 
;------------------------------------------------------------
        movlw   0x20       ; 
        movwf   FSR        ; 
clear_mem:                 ;
        clrf    INDF       ; 
        incf    FSR,f      ; ..   
        cpi     FSR,0x7F   ;  = 0
        jnz     clear_mem  ;
        clrwdt             ;  WDT 
;-------------------------------------------------------------
        mvi  first,1          ; 1-  DMX
        mvi  AdrTab,0xff      ;    !!!
;-------------------------------------------------------------
        mvi  dmx_1,.100    ;  1 
        mvi  dmx_2,.100    ;  2 
        mvi  dmx_3,.100    ;  3 
        mvi  dmx_4,.100    ;  4 
;-------------------------------------------------------------
        mvi  LevelCap1,.050    ;  1 
        mvi  LevelCap2,.050    ;  2 
        mvi  LevelCap3,.050    ;  3 
        mvi  LevelCap4,.050    ;  4 
;*************************************************************
BaseCarryCuc: ; --      -----
;*************************************************************
        clrwdt             ;  WDT 
        btfss    TMR0,6    ; -6-   50  !!!
        goto    noCountU   ;  6=0 -> 
        clrf     TMR0      ;  6=1 ->  
        incf    CountUniv,f;  , Program
        jnz     noCountU   ;     
        incf    CountProg,f;     | 
        incf    CountPosl,f;   |  
noCountU:                  ;                |   
        incf    Cap1count,f ;
        incf    Cap2count,f ;
        incf    Cap3count,f ;
        incf    Cap4count,f ;
;-------------------------------------------------
        call    Cap1Move     ; 1   ( )
        call    Cap2Move     ; 2   ( )
        call    Cap3Move     ; 3   ( )
        call    Cap4Move     ; 4   ( )
;-------------------------------------------------
        incf    Divider,f     ; 
        movlw   0x0f          ;   
        andwf   Divider,w     ;  
        jnz     BaseCarryCuc  ;   
;-------------------------------------------------
        cpi     Divider,0x00  ;  
        jz      CheckCap1     ;   
        cpi     Divider,0x30  ;  
        jz      CheckCap2     ;    
        cpi     Divider,0x60  ;   
        jz      CheckCap3     ;
        cpi     Divider,0x90  ;
        jz      CheckCap4     ;
        cpi     Divider,0xC0  ;
        jz      CheckSwith    ;
;---    ------------------------
        cpi     PORTB,0xff    ;     ?
        jnz     BaseCarryCuc  ; not
; ------      ---------------

        btfsc   Fweit        ;    
        goto    mus_gate     ;  =1,  
        cpi     CountProg,konst_m ;   
        jc      BaseCarryCuc ; ,      
        clrf    CountProg    ;   
        bsf     Fweit        ;   (=1)  
        goto    BaseCarryCuc ;   
mus_gate:
        btfss   Musik        ;   ?
        goto    BaseCarryCuc ;  
        bcf     Fweit        ; . -   
        call    FollowProg   ;    
        goto    BaseCarryCuc  ;   
;**********************************************************
CheckSwith:  ;   
;**********************************************************
;               goto    ModeProgram
;               goto    ModeMusik
         cpi     PORTB,0xff        ;     ?
         jz      ModeMusik         ;
         cpi     PORTB,0           ;    ?
         jz      ModeProgram       ;
        comf    PORTB,w            ;   
        movwf     first            ;   DMX
        mov     LevelCap1,dmx_1    ;  1
        mov     LevelCap2,dmx_2    ;  2
        mov     LevelCap3,dmx_3    ;  3
        mov     LevelCap4,dmx_4    ;  4
        goto    BaseCarryCuc       ;   
;**********************************************************
ModeMusik:      ;     
;**********************************************************
        call    Posle         ;   10  
        goto    BaseCarryCuc ;   
;**********************************************************
ModeProgram:   ;  
;**********************************************************
        cpi     CountProg,konst_r;    
        jnz     BaseCarryCuc     ;     
        clrf    CountProg        ; , o 
        call    FollowProg       ;  
        goto    BaseCarryCuc     ;   
;**********************************************************
CheckCap1: ;     1
;**********************************************************
        bcf     FStopCap1      ;  STOP
        cpi     LevelCap1,.124 ;  121  134 
        jc      job_C1         ; <124  
        cpi     LevelCap1,.131 ;
        jc      BaseCarryCuc   ;  
job_C1:                        ; >131  
        bsf     FStopCap1      ;  
        mov     SpeedCap1,LevelCap1
        btfsc   LevelCap1,7    ;   > 127 
        comf    SpeedCap1,f    ;  
        rrf     SpeedCap1,f    ;
        rrf     SpeedCap1,f    ;
        rrf     SpeedCap1,f    ;
        movlw   0x0f           ;
        andwf   SpeedCap1,w    ; 
        call    TabSpeed       ;   
        movwf   SpeedCap1      ;  
        goto    BaseCarryCuc   ;   
;**********************************************************
CheckCap2: ;     2
;**********************************************************
        bcf     FStopCap2      ;  STOP
        cpi     LevelCap2,.124 ;  121  134 
        jc      job_C2         ; <124  
        cpi     LevelCap2,.131 ;
        jc      BaseCarryCuc   ;  
job_C2:                        ; >131  
        bsf     FStopCap2      ;  
        mov     SpeedCap2,LevelCap2
        btfsc   LevelCap2,7    ;   > 127 
        comf    SpeedCap2,f    ;  
        rrf     SpeedCap2,f    ;
        rrf     SpeedCap2,f    ;
        rrf     SpeedCap2,f    ;
        movlw   0x0f           ;
        andwf   SpeedCap2,w    ; 
        call    TabSpeed       ;   
        movwf   SpeedCap2      ;  
        goto    BaseCarryCuc   ;   
;**********************************************************
CheckCap3: ;     3
;**********************************************************
        bcf     FStopCap3      ;  STOP
        cpi     LevelCap3,.124 ;  121  134 
        jc      job_C3         ; <124  
        cpi     LevelCap3,.131 ;
        jc      BaseCarryCuc   ;  
job_C3:                        ; >131  
        bsf     FStopCap3      ;  
        mov     SpeedCap3,LevelCap3
        btfsc   LevelCap3,7    ;   > 127 
        comf    SpeedCap3,f    ;  
        rrf     SpeedCap3,f    ;
        rrf     SpeedCap3,f    ;
        rrf     SpeedCap3,f    ;
        movlw   0x0f           ;
        andwf   SpeedCap3,w    ; 
        call    TabSpeed       ;   
        movwf   SpeedCap3      ;  
        goto    BaseCarryCuc   ;   
;**********************************************************
CheckCap4: ;     4
;**********************************************************
        bcf     FStopCap4      ;  STOP
        cpi     LevelCap4,.124 ;  121  134 
        jc      job_C4         ; <124  
        cpi     LevelCap4,.131 ;
        jc      BaseCarryCuc   ;  
job_C4:                        ; >131  
        bsf     FStopCap4      ;  
        mov     SpeedCap4,LevelCap4
        btfsc   LevelCap4,7    ;   > 127 
        comf    SpeedCap4,f    ;  
        rrf     SpeedCap4,f    ;
        rrf     SpeedCap4,f    ;
        rrf     SpeedCap4,f    ;
        movlw   0x0f           ;
        andwf   SpeedCap4,w    ; 
        call    TabSpeed       ;   
        movwf   SpeedCap4      ;  
        goto    BaseCarryCuc   ;   
;**************************************************************
FollowProg:  ;    
;**************************************************************
        clrf    PCLATH          ;
        incf    AdrTab,f        ;  
        cpi     AdrTab,long_tab ;   
        jnz     foll_obx        ;   arg = const
        clrf    AdrTab          ;    = 0
foll_obx:
        movf    AdrTab,w        ;   -> W
        call    TabComand       ;  
        movwf   DataTab         ;  
;==========================================================
        movwf   DataTemp        ;   
        movlw   b'11100000'     ;
        andwf   DataTemp,f      ;
;==========================================================
; 0x,1x-CAP1    2x,3x-CAP2   4x,5x - CAP3   6x,7x - CAP4
; Ax,Bx -       
        cpi     DataTemp,0x00     ;
        jz      AnalizCap1        ; 
        cpi     DataTemp,0x20     ;  
        jz      AnalizCap2        ; 
        cpi     DataTemp,0x40
        jz      AnalizCap3
        cpi     DataTemp,0x60
        jz      AnalizCap4
        cpi     DataTemp,0xA0
        jz      AnalizTogethe
        return
;-----------------------------------------------------------------------
AnalizTogethe:              ;    
        call    WorkCaps    ;   
        mov     LevelCap1,DataTemp ;   
        mov     LevelCap2,DataTemp ;
        mov     LevelCap3,DataTemp ;
        mov     LevelCap4,DataTemp ;
        return
;-----------------------------------------------------------------------
AnalizCap1: ; 40h  = + 4=
         call    WorkCaps    ;   
         mov     LevelCap1,DataTemp ;   
         return
;-----------------------------------------------------------------------
AnalizCap2: ; 40h  = + 4=
         call    WorkCaps    ;   
         mov     LevelCap2,DataTemp ;   
         return
;-----------------------------------------------------------------------
AnalizCap3: ; 40h  = + 4=
         call    WorkCaps    ;   
         mov     LevelCap3,DataTemp ;   
         return
;-----------------------------------------------------------------------
AnalizCap4: ; 40h  = + 4=
         call    WorkCaps    ;   
         mov     LevelCap4,DataTemp ;   
         return
;-----------------------------------------------------------------------
WorkCaps: ;      
         mov     DataTemp,DataTab  ;
         btfss   DataTemp,4        ;   = 0
         call    invers            ; 
         rlf     DataTemp,f        ;  32 
         rlf     DataTemp,f        ;   - 16 
         rlf     DataTemp,f        ;  
         movlw   b'11111000'       ;
         andwf   DataTemp,f        ;
         return
;-----------------------------------------------------------------------
invers:
         comf    DataTemp,f        ; 
         nop                       ;
         bcf     DataTemp,4        ;
         return
;***********************************************************************
Posle:        ;    3 
;***********************************************************************
        btfss   Musik          ;   
        goto    posl_nogate    ;    ?
        clrf    CountPosl      ;   
        clrf    CountPosh      ;   
        return
posl_nogate:                   ;  
        cpi     CountPosl,.250 ;    
        rnz                    ; ret,      
        incf    CountPosh,f    ;
        cpi     CountPosh,konst_;  3 
        jnz     posl_noCap       ;
        mvi     LevelCap1,.130    ; STOP  1
        mvi     LevelCap2,.130    ; STOP  2
        mvi     LevelCap3,.130    ; STOP  3
        mvi     LevelCap4,.130    ; STOP  4
posl_noCap:
        cpi     CountPosh,konst_p;  15 
        rnz                      ;      
        clrf    CountPosl        ;   
        return
;**************************************************************
;      -  
;**************************************************************
int_dmx:                       ;
        movwf   temp_w         ;  W
        swapf   STATUS,w       ;  Status
        bcf     STATUS,RP0     ;  0
        movwf   temp_s         ; c  PUSH
;---------     !!! ------------------
        movf    FSR,w          ;  fsr
        movwf   temp_fsr       ;
;-------   -------------------------------------
        btfsc   RCSTA,2        ;  -  STOP-BIT
        goto    int_gate       ;   
        btfsc   flag_0         ;    
        goto    int_wait00     ;     =00=
        btfsc   flag_1         ;
        goto    int_reciv      ;   
        btfsc   flag_2         ;
        goto    int_write      ;   
        clrf    Flagsdmx       ;  
        mov     rx,RCREG       ;   
        goto    ret_int        ;   
;---------------------------------------------------------------
int_wait00:                    ;   =00=
        mov     rx,RCREG       ;   
        mvi     tekuch,1       ;  
        cpi     rx,0x00        ;   =00=  
        jnz     ret_int        ;    
        bcf     flag_0         ;   
        bsf     flag_1         ; .  
        goto    ret_int        ;  =00=   
;---------------------------------------------------------------
int_reciv:                     ;    
        bcf     flag_0         ;   
        bsf     flag_1         ; .  
        mvi     channel,1      ;  
        cmp     tekuch,first   ;    
        jz      int_write      ;    
        mov     rx,RCREG       ;   
        incf    tekuch,f       ;   DMX
        goto    ret_int        ;   
;---------------------------------------------------------------
int_write:
        bcf     flag_1         ; c  
        bsf     flag_2         ; .  
        mvi     FSR,dmx_0      ; 
        movf    channel,w      ;   
        addwf   FSR,f          ;  
        mov     INDF,RCREG     ;   
        incf    channel,f      ;  
        cpi     channel,.7     ;  
        jnz     ret_int        ;    
        clrf    Flagsdmx       ; c  - 
        goto    ret_int        ;   
;---------------------------------------------------------------
int_gate:        ;    DMX
        bsf     flag_0         ; .  
        mov     rx,RCREG       ;   
ret_int:
        bcf     PIR1,5         ; USART -  !!!
        movf    temp_fsr,w     ;
        movwf   FSR            ; return fsr
        swapf   temp_s,w       ; c  POP
        movwf   STATUS         ;  Status
        swapf   temp_w,f       ;  W 
        swapf   temp_w,w       ;   Z !
        retfie      ;       
;************************************************************
;************************************************************
;************************************************************
        ORG     600h
;************************************************************
Cap1Move:  ;   =  1
;************************************************************
        btfss   FStopCap1    ;   
        return               ;  
        btfsc   LevelCap1,7  ;  
        goto    Cap1Left     ; 
        movf    SpeedCap1,w  ;  : c
        subwf   Cap1count,w  ;   
        btfss   STATUS,CR    ;   
        goto    cross_C1     ; ,  
        clrf    Cap1count    ;   
        incf    Cap1step,f   ;   
        jnz     cross_C1     ;   = 0  
        decf    Cap1swith,f  ;     
        movlw   b'00000011'  ; (   )
        andwf   Cap1swith,f  ;   
cross_C1:                    ;
        decf    Cap1Sqw,f    ;  
        mvi     PCLATH,6     ; org 600h  <<<<<<<<<<<<<<<<<<<<<
        movf    Cap1swith,w  ;  
        addwf   PC,f
        goto    Cap1varR4   ; 4
        goto    Cap1varR3   ; 3
        goto    Cap1varR2   ; 2
        goto    Cap1varR1   ; 1
;-------------------------------------------------------------
Cap1varR1: ;     
        cmp     Cap1Sqw,Cap1step ;   
        btfsc   STATUS,0         ;
        goto    c1st100010       ;   - 1->0
        goto    c1st100100       ;   - 0->1
;-------------------------------------------------------------
Cap1varR2: ;     
        cmp     Cap1Sqw,Cap1step ;   
        btfsc   STATUS,0
        goto    c1st010010       ;   - 1->0
        goto    c1st100010       ;   - 0->1
;-------------------------------------------------------------
Cap1varR3: ;     
        cmp     Cap1Sqw,Cap1step ;   
        btfsc   STATUS,0
        goto    c1st010100       ;   - 1->0
        goto    c1st010010       ;   - 0->1
;-------------------------------------------------------------
Cap1varR4: ;     
        cmp     Cap1Sqw,Cap1step ;   
        btfsc   STATUS,0
        goto    c1st100100       ;   - 1->0
        goto    c1st010100       ;   - 0->1
;-------------------------------------------------------------
Cap1Left:  ;   =  
;-------------------------------------------------------------
        movf    SpeedCap1,w
        subwf   Cap1count,w  ;   
        btfss   STATUS,CR    ;   
        goto    cross1_k1    ; ,  
        clrf    Cap1count    ;   
        incf    Cap1step,f   ;   
        jnz     cross1_k1    ;   = 0  
        incf    Cap1swith,f  ; ???    
        movlw   b'00000011'  ; (   )
        andwf   Cap1swith,f  ;   
cross1_k1:                   ;
        incf    Cap1Sqw,f     ;  
        mvi     PCLATH,6      ; org 600h <<<<<<<<<<<<<<<<<<<<
        movf    Cap1swith,w  ;
        addwf   PC,f
        goto    Cap1varL4   ;
        goto    Cap1varL3   ;
        goto    Cap1varL2   ;
        goto    Cap1varL1   ;
;-------------------------------------------------------------
Cap1varL1: ;     
        cmp     Cap1Sqw,Cap1step ;   
        btfss   STATUS,0        ;
        goto    c1st100010       ;   - 1->0
        goto    c1st100100       ;   - 0->1
;-------------------------------------------------------------
Cap1varL2: ;     
        cmp     Cap1Sqw,Cap1step ;   
        btfss   STATUS,0
        goto    c1st010010       ;   - 1->0
        goto    c1st100010       ;   - 0->1
;-------------------------------------------------------------
Cap1varL3: ;     
        cmp     Cap1Sqw,Cap1step ;   
        btfss   STATUS,0
        goto    c1st010100       ;   - 1->0
        goto    c1st010010       ;   - 0->1
;-------------------------------------------------------------
Cap1varL4: ;     
        cmp     Cap1Sqw,Cap1step ;   
        btfss   STATUS,0
        goto    c1st100100       ;   - 1->0
        goto    c1st010100       ;   - 0->1
;-------------------------------------------------------------
c1st100010:           ; 1
     bsf  Cap1A       ;    =A= 
     bcf  Cap1B       ;    =B= 
     clrf PCLATH
     return           ;
c1st100100:           ; 2
     bsf  Cap1A       ;    =A= 
     bsf  Cap1B       ;    =B= 
     clrf PCLATH
     return           ;
c1st010010:           ; 3
     bcf  Cap1A       ;    =A= 
     bcf  Cap1B       ;    =B= 
     clrf PCLATH
     return           ;
c1st010100:           ; 4
     bcf  Cap1A       ;    =A= 
     bsf  Cap1B       ;    =B= 
     clrf PCLATH
     return           ;
;************************************************************
;************************************************************
;************************************************************
Cap2Move:  ;   =  2
;************************************************************
        btfss   FStopCap2    ;   
        return               ;  
        btfsc   LevelCap2,7  ;  
        goto    Cap2Left     ; 
        movf    SpeedCap2,w  ;  : c
        subwf   Cap2count,w  ;   
        btfss   STATUS,CR    ;   
        goto    cross_C2     ; ,  
        clrf    Cap2count    ;   
        incf    Cap2step,f   ;   
        jnz     cross_C2     ;   = 0  
        decf    Cap2swith,f  ;     
        movlw   b'00000011'  ; (   )
        andwf   Cap2swith,f  ;   
cross_C2:                    ;
        decf    Cap2Sqw,f    ;  
        mvi     PCLATH,6     ; org 600h  <<<<<<<<<<<<<<<<<<<<<
        movf    Cap2swith,w  ;  
        addwf   PC,f
        goto    Cap2varR4   ; 4
        goto    Cap2varR3   ; 3
        goto    Cap2varR2   ; 2
        goto    Cap2varR1   ; 1
;-------------------------------------------------------------
Cap2varR1: ;     
        cmp     Cap2Sqw,Cap2step ;   
        btfsc   STATUS,0         ;
        goto    c2st100010       ;   - 1->0
        goto    c2st100100       ;   - 0->1
;-------------------------------------------------------------
Cap2varR2: ;     
        cmp     Cap2Sqw,Cap2step ;   
        btfsc   STATUS,0
        goto    c2st010010       ;   - 1->0
        goto    c2st100010       ;   - 0->1
;-------------------------------------------------------------
Cap2varR3: ;     
        cmp     Cap2Sqw,Cap2step ;   
        btfsc   STATUS,0
        goto    c2st010100       ;   - 1->0
        goto    c2st010010       ;   - 0->1
;-------------------------------------------------------------
Cap2varR4: ;     
        cmp     Cap2Sqw,Cap2step ;   
        btfsc   STATUS,0
        goto    c2st100100       ;   - 1->0
        goto    c2st010100       ;   - 0->1
;-------------------------------------------------------------
Cap2Left:  ;   =  
;-------------------------------------------------------------
        movf    SpeedCap2,w
        subwf   Cap2count,w  ;   
        btfss   STATUS,CR    ;   
        goto    cross2_k1    ; ,  
        clrf    Cap2count    ;   
        incf    Cap2step,f   ;   
        jnz     cross2_k1    ;   = 0  
        incf    Cap2swith,f  ; ???    
        movlw   b'00000011'  ; (   )
        andwf   Cap2swith,f  ;   
cross2_k1:                   ;
        incf    Cap2Sqw,f     ;  
        mvi     PCLATH,6      ; org 500h <<<<<<<<<<<<<<<<<<<<
        movf    Cap2swith,w  ;
        addwf   PC,f
        goto    Cap2varL4   ;
        goto    Cap2varL3   ;
        goto    Cap2varL2   ;
        goto    Cap2varL1   ;
;-------------------------------------------------------------
Cap2varL1: ;     
        cmp     Cap2Sqw,Cap2step ;   
        btfss   STATUS,0        ;
        goto    c2st100010       ;   - 1->0
        goto    c2st100100       ;   - 0->1
;-------------------------------------------------------------
Cap2varL2: ;     
        cmp     Cap2Sqw,Cap2step ;   
        btfss   STATUS,0
        goto    c2st010010       ;   - 1->0
        goto    c2st100010       ;   - 0->1
;-------------------------------------------------------------
Cap2varL3: ;     
        cmp     Cap2Sqw,Cap2step ;   
        btfss   STATUS,0
        goto    c2st010100       ;   - 1->0
        goto    c2st010010       ;   - 0->1
;-------------------------------------------------------------
Cap2varL4: ;     
        cmp     Cap2Sqw,Cap2step ;   
        btfss   STATUS,0
        goto    c2st100100       ;   - 1->0
        goto    c2st010100       ;   - 0->1
;-------------------------------------------------------------
c2st100010:           ; 1
     bsf  Cap2A       ;    =A= 
     bcf  Cap2B       ;    =B= 
     clrf PCLATH
     return           ;
c2st100100:           ; 2
     bsf  Cap2A       ;    =A= 
     bsf  Cap2B       ;    =B= 
     clrf PCLATH
     return           ;
c2st010010:           ; 3
     bcf  Cap2A       ;    =A= 
     bcf  Cap2B       ;    =B= 
     clrf PCLATH
     return           ;
c2st010100:           ; 4
     bcf  Cap2A       ;    =A= 
     bsf  Cap2B       ;    =B= 
     clrf PCLATH
     return           ;
;************************************************************
        ORG     700h
;************************************************************
Cap3Move:  ;   =  3
;************************************************************
        btfss   FStopCap3    ;   
        return               ;  
        btfsc   LevelCap3,7  ;  
        goto    Cap3Left     ; 
        movf    SpeedCap3,w  ;  : c
        subwf   Cap3count,w  ;   
        btfss   STATUS,CR    ;   
        goto    cross_C3     ; ,  
        clrf    Cap3count    ;   
        incf    Cap3step,f   ;   
        jnz     cross_C3     ;   = 0  
        decf    Cap3swith,f  ;     
        movlw   b'00000011'  ; (   )
        andwf   Cap3swith,f  ;   
cross_C3:                    ;
        decf    Cap3Sqw,f    ;  
        mvi     PCLATH,7     ; org 700h  <<<<<<<<<<<<<<<<<<<<<
        movf    Cap3swith,w  ;  
        addwf   PC,f
        goto    Cap3varR4   ; 4
        goto    Cap3varR3   ; 3
        goto    Cap3varR2   ; 2
        goto    Cap3varR1   ; 1
;-------------------------------------------------------------
Cap3varR1: ;     
        cmp     Cap3Sqw,Cap3step ;   
        btfsc   STATUS,0         ;
        goto    c3st100010       ;   - 1->0
        goto    c3st100100       ;   - 0->1
;-------------------------------------------------------------
Cap3varR2: ;     
        cmp     Cap3Sqw,Cap3step ;   
        btfsc   STATUS,0
        goto    c3st010010       ;   - 1->0
        goto    c3st100010       ;   - 0->1
;-------------------------------------------------------------
Cap3varR3: ;     
        cmp     Cap3Sqw,Cap3step ;   
        btfsc   STATUS,0
        goto    c3st010100       ;   - 1->0
        goto    c3st010010       ;   - 0->1
;-------------------------------------------------------------
Cap3varR4: ;     
        cmp     Cap3Sqw,Cap3step ;   
        btfsc   STATUS,0
        goto    c3st100100       ;   - 1->0
        goto    c3st010100       ;   - 0->1
;-------------------------------------------------------------
Cap3Left:  ;   =  
;-------------------------------------------------------------
        movf    SpeedCap3,w
        subwf   Cap3count,w  ;   
        btfss   STATUS,CR    ;   
        goto    cross3_k1    ; ,  
        clrf    Cap3count    ;   
        incf    Cap3step,f   ;   
        jnz     cross3_k1    ;   = 0  
        incf    Cap3swith,f  ; ???    
        movlw   b'00000011'  ; (   )
        andwf   Cap3swith,f  ;   
cross3_k1:                   ;
        incf    Cap3Sqw,f     ;  
        mvi     PCLATH,7      ; org 700h <<<<<<<<<<<<<<<<<<<<
        movf    Cap3swith,w  ;
        addwf   PC,f
        goto    Cap3varL4   ;
        goto    Cap3varL3   ;
        goto    Cap3varL2   ;
        goto    Cap3varL1   ;
;-------------------------------------------------------------
Cap3varL1: ;     
        cmp     Cap3Sqw,Cap3step ;   
        btfss   STATUS,0        ;
        goto    c3st100010       ;   - 1->0
        goto    c3st100100       ;   - 0->1
;-------------------------------------------------------------
Cap3varL2: ;     
        cmp     Cap3Sqw,Cap3step ;   
        btfss   STATUS,0
        goto    c3st010010       ;   - 1->0
        goto    c3st100010       ;   - 0->1
;-------------------------------------------------------------
Cap3varL3: ;     
        cmp     Cap3Sqw,Cap3step ;   
        btfss   STATUS,0
        goto    c3st010100       ;   - 1->0
        goto    c3st010010       ;   - 0->1
;-------------------------------------------------------------
Cap3varL4: ;     
        cmp     Cap3Sqw,Cap3step ;   
        btfss   STATUS,0
        goto    c3st100100       ;   - 1->0
        goto    c3st010100       ;   - 0->1
;-------------------------------------------------------------
c3st100010:           ; 1
     bsf  Cap3A       ;    =A= 
     bcf  Cap3B       ;    =B= 
     clrf PCLATH
     return           ;
c3st100100:           ; 2
     bsf  Cap3A       ;    =A= 
     bsf  Cap3B       ;    =B= 
     clrf PCLATH
     return           ;
c3st010010:           ; 3
     bcf  Cap3A       ;    =A= 
     bcf  Cap3B       ;    =B= 
     clrf PCLATH
     return           ;
c3st010100:           ; 4
     bcf  Cap3A       ;    =A= 
     bsf  Cap3B       ;    =B= 
     clrf PCLATH
     return           ;
;************************************************************
;************************************************************
;************************************************************
Cap4Move:  ;   =  4
;************************************************************
        btfss   FStopCap4    ;   
        return               ;  
        btfsc   LevelCap4,7  ;  
        goto    Cap4Left     ; 
        movf    SpeedCap4,w  ;  : c
        subwf   Cap4count,w  ;   
        btfss   STATUS,CR    ;   
        goto    cross_C4     ; ,  
        clrf    Cap4count    ;   
        incf    Cap4step,f   ;   
        jnz     cross_C4     ;   = 0  
        decf    Cap4swith,f  ;     
        movlw   b'00000011'  ; (   )
        andwf   Cap4swith,f  ;   
cross_C4:                    ;
        decf    Cap4Sqw,f    ;  
        mvi     PCLATH,7     ; org 700h  <<<<<<<<<<<<<<<<<<<<<
        movf    Cap4swith,w  ;  
        addwf   PC,f
        goto    Cap4varR4   ; 4
        goto    Cap4varR3   ; 3
        goto    Cap4varR2   ; 2
        goto    Cap4varR1   ; 1
;-------------------------------------------------------------
Cap4varR1: ;     
        cmp     Cap4Sqw,Cap4step ;   
        btfsc   STATUS,0         ;
        goto    c4st100010       ;   - 1->0
        goto    c4st100100       ;   - 0->1
;-------------------------------------------------------------
Cap4varR2: ;     
        cmp     Cap4Sqw,Cap4step ;   
        btfsc   STATUS,0
        goto    c4st010010       ;   - 1->0
        goto    c4st100010       ;   - 0->1
;-------------------------------------------------------------
Cap4varR3: ;     
        cmp     Cap4Sqw,Cap4step ;   
        btfsc   STATUS,0
        goto    c4st010100       ;   - 1->0
        goto    c4st010010       ;   - 0->1
;-------------------------------------------------------------
Cap4varR4: ;     
        cmp     Cap4Sqw,Cap4step ;   
        btfsc   STATUS,0
        goto    c4st100100       ;   - 1->0
        goto    c4st010100       ;   - 0->1
;-------------------------------------------------------------
Cap4Left:  ;   =  
;-------------------------------------------------------------
        movf    SpeedCap4,w
        subwf   Cap4count,w  ;   
        btfss   STATUS,CR    ;   
        goto    cross4_k1    ; ,  
        clrf    Cap4count    ;   
        incf    Cap4step,f   ;   
        jnz     cross4_k1    ;   = 0  
        incf    Cap4swith,f  ; ???    
        movlw   b'00000011'  ; (   )
        andwf   Cap4swith,f  ;   
cross4_k1:                   ;
        incf    Cap4Sqw,f     ;  
        mvi     PCLATH,7      ; org 700h <<<<<<<<<<<<<<<<<<<<
        movf    Cap4swith,w  ;
        addwf   PC,f
        goto    Cap4varL4   ;
        goto    Cap4varL3   ;
        goto    Cap4varL2   ;
        goto    Cap4varL1   ;
;-------------------------------------------------------------
Cap4varL1: ;     
        cmp     Cap4Sqw,Cap4step ;   
        btfss   STATUS,0        ;
        goto    c4st100010       ;   - 1->0
        goto    c4st100100       ;   - 0->1
;-------------------------------------------------------------
Cap4varL2: ;     
        cmp     Cap4Sqw,Cap4step ;   
        btfss   STATUS,0
        goto    c4st010010       ;   - 1->0
        goto    c4st100010       ;   - 0->1
;-------------------------------------------------------------
Cap4varL3: ;     
        cmp     Cap4Sqw,Cap4step ;   
        btfss   STATUS,0
        goto    c4st010100       ;   - 1->0
        goto    c4st010010       ;   - 0->1
;-------------------------------------------------------------
Cap4varL4: ;     
        cmp     Cap4Sqw,Cap4step ;   
        btfss   STATUS,0
        goto    c4st100100       ;   - 1->0
        goto    c4st010100       ;   - 0->1
;-------------------------------------------------------------
c4st100010:           ; 1
     bsf  Cap4A       ;    =A= 
     bcf  Cap4AI      ;  
     bcf  Cap4B       ;    =B= 
     bsf  Cap4BI      ;  
     clrf PCLATH
     return           ;
c4st100100:           ; 2
     bsf  Cap4A       ;    =A= 
     bcf  Cap4AI      ;  
     bsf  Cap4B       ;    =B= 
     bcf  Cap4BI      ;  
     clrf PCLATH
     return           ;
c4st010010:           ; 3
     bcf  Cap4A       ;    =A= 
     bsf  Cap4AI      ;  
     bcf  Cap4B       ;    =B= 
     bsf  Cap4BI      ;  
     clrf PCLATH
     return           ;
c4st010100:           ; 4
     bcf  Cap4A       ;    =A= 
     bsf  Cap4AI      ;  
     bsf  Cap4B       ;    =B= 
     bcf  Cap4BI      ;  
     clrf PCLATH
     return           ;
;**************************************************************
  End  ;    BrSoft Copyright (C) 2004 Bogdanov Andrew
;**************************************************************






