;*************************************************************
; Vers 1.5  (DMX)    CARRY
;************************************************************
;   Filename:           Scaner.asm
;   Date:               november 2004
;   Assembler:          mpasm 3.20
;   Author:             Bogdanov Andrew
;************************************************************
;  LIST   p=16F73  ; cp=off=1. 3pwrt|on=1. 2wdt|on=1. =HS   *
 __CONFIG b'00000011000010'        ;   CP on      *
;************************************************************
#include pic73.mac ;                                     *
;************************************************************
;           Bit Definitions                                 *
;************************************************************
#define  flag_0   Flagsdmx,0  ;                       *
#define  flag_1   Flagsdmx,1  ;                *
#define  flag_2   Flagsdmx,2  ;                  *
#define  flag_3   Flagsdmx,3  ;  DMX                 *
#define  flag_d   Flagsdmx,4  ; news                       *
;************************************************************
#define  FlagEnable  Flags,0  ;   DMX
;************************************************************
#define  ScanXa    PORTC,0  ;    =A=
#define  ScanXb    PORTC,3  ;    =B=
#define  ScanYa    PORTC,4  ;    =A=
#define  ScanYb    PORTC,5  ;    =B=
;************************************************************
ScanXstep    equ   0x20  ;   
ScanXsqw     equ   0x21  ;   
ScanXswith   equ   0x22  ;  
ScanXcount   equ   0x23  ;    
ScanXSpeed   equ   0x24  ;   
ScanXinput   equ   0x25  ;     DMX512
ScanXold     equ   0x26  ;   
ScanXLevel   equ   0x27  ;    
ScanXrun     equ   0x28  ;   
;------------------------------------------------------------
ScanYstep    equ   0x30  ;   
ScanYSqw     equ   0x31  ;   
ScanYswith   equ   0x32  ;  
ScanYcount   equ   0x33  ;    
ScanYSpeed   equ   0x34  ;   
ScanYinput   equ   0x35  ;     DMX512
ScanYold     equ   0x36  ;   
ScanYLevel   equ   0x37  ;    
ScanYrun     equ   0x38  ;   
;------------------------------------------------------------
Gobocount    equ   0x40  ;    
Shimswith    equ   0x41  ;
GoboSpeed    equ   0x42  ;   
GoboInput    equ   0x43  ;     DMX512
GoboLevel    equ   0x44  ;    
GoboRun      equ   0x45  ;   
;***************************************************************
Divider      equ   0x48  ; - .swith  
Flags        equ   0x49  ; ,   
;*************************************************************
dmx_0        equ  0x50   ; 0-
dmx_1        equ  0x51   ;  
dmx_2        equ  0x52   ; GOBO + OLOR + RainBow + Strob
dmx_3        equ  0x53   ;  
dmx_4        equ  0x54   ;  Y
dmx_5        equ  0x55   ;  
dmx_6        equ  0x56   ;  
dmx_7        equ  0x57   ;  
dmx_8        equ  0x58   ;
;*************    DMX *************************
Flagsdmx    equ   0x70  ; \   
temp_cnt    equ   0x71  ; \ Int    
temp_rx     equ   0x72  ; \ Int     
temp_s      equ   0x73  ; \ Int  
temp_w      equ   0x74  ; \
temp_fsr    equ   0x75  ; \ Int    
rx          equ   0x76  ;   DMX
mode_int    equ   0x77  ;    
first       equ   0x78  ;    
tekuch      equ   0x79  ;    
channel     equ   0x7A  ;    
;*************************************************************
        ORG     0        ;  
;***********************************************************************
        goto    Start    ;
        nop              ;
        nop              ;
        nop              ;  = 0004h
        goto    int_dmx  ;    -  
;*************************************************************
TabGobo:   andlw 0x0f ;
           addwf PC,f ;       GOBO
 dt  .000,.014,.026,.038,.050,.062,.074,.086 ;
 dt  .098,.110,.122,.134,.146,.158,.170,.182 ;
;***********************************************************************
        ORG    100H                 ;  
;***********************************************************************
Start:                              ; Main Programm
            bsf         STATUS,RP0  ; c 1
            movlw       b'00011111' ; A0-4 =in
            movwf       TRISA       ; A5  = out
            movlw       b'11111111' ; B0-B7 - inputs
            movwf       TRISB       ; DMX address
            movlw       b'10000000' ; C0-C6-out stepmotor
            movwf       TRISC       ; C7=RX,C6=TX
            movlw       b'00000000' ; 1:2-HS->Presc->Tmr0,
            movwf       OPTIONR     ;   :50 !!!
            movlw       b'00000100' ;  A2,4,5
            movwf       ADCON1      ; analog A0,1,3
            movlw       b'00100000' ;  
            movwf       PIE1        ; USART
            movlw       d'000'      ; =0, brg=0
            movwf       SPBRG       ; USART
            movlw       b'00100010' ;  BRGH =1 high
            movwf       TXSTA       ; USART      bit2 =0 low
            bcf         STATUS,RP0  ; c 0
;*************************************************************
            movlw       b'10011101' ;  
            movwf       ADCON0      ; ADC
            movlw       b'10010000' ;  
            movwf       RCSTA       ; USART
            movlw       b'00000000' ; (bit 5 = 0   data
            movwf       PIR1        ; USART -  !!!
            movlw       b'11000000' ;  
            movwf       INTCON      ; 
            movlw       b'00001100' ; mode  1
            movwf       CCP1CON     ; adr 17h
            movlw       b'00001100' ; mode  2
            movwf       CCP2CON     ; adr 1dh
            movlw       .063         ;   - 8 
            movwf       PR2         ; 63 = 39  (F=10Mhz)
            movlw       b'00000100' ;  2 - = 1:1
            movwf       T2CON       ; - = 1:1
;------------------------------------------------------------
        movlw   0x20       ; 
        movwf   FSR        ; 
clear_mem:                 ;
        clrf    INDF       ; 
        incf    FSR,f      ; ..   
        cpi     FSR,0x7F   ;  = 0
        jnz     clear_mem  ;
;-------------------------------------------------------------
; c    
;----------------------------------------------------------
     mvi     dmx_1,.0      ; gobo open
     mvi     dmx_2,.0      ; X
     mvi     dmx_3,.0      ; Y
;-------------------------------------------------------------
     mvi     GoboSpeed,.5   ; 10  GOBO
     clrf    GoboLevel      ;     
     mvi     GoboRun,.200   ;
;----------------------------------------------------------
     mvi     ScanXSpeed,.20 ; 
     clrf    ScanXLevel     ;     
     mvi     ScanXrun,.35   ;
;----------------------------------------------------------
     mvi     ScanYSpeed,.20; 
     clrf    ScanYLevel     ;     
     mvi     ScanYrun,.20   ;
;*************************************************************
BaseCarryCuc: ; --      -----
;*************************************************************
        clrwdt             ;  WDT 
        btfss    TMR0,6    ; -6-   50  !!!
        goto    NoPlus     ;  6=0 -> 
        clrf     TMR0      ;  6=1 ->  
        incf    ScanXcount,f;  
        incf    ScanYcount,f ;
        incf    Gobocount,f;   Low=0
NoPlus:
;-------------------------------------------------
        call    GoboMove    ;  Gobo ( )
        call    ScanXMove   ;   ( )
        call    ScanYMove   ;   ( )
;-------------------------------------------------
        incf    Divider,f     ; 
        jz      CheckSwith    ;  
;       cpi     Divider,127   ;
;       jz      CheckInt      ;
        goto    BaseCarryCuc  ;
;**********************************************************
CheckInt:
;**********************************************************
           goto   BaseCarryCuc
;**********************************************************
CheckSwith:  ;   
;**********************************************************
        btfss   FlagEnable        ;   INIT
        goto    BaseCarryCuc      ;   
        comf    PORTB,w           ;   
        movwf   first             ;   DMX
        mov     GoboInput,dmx_1   ;
        mov     ScanXinput,dmx_2   ; 
        mov     ScanYinput,dmx_3   ;
        goto    BaseCarryCuc     ;   
;**************************************************************
int_dmx: ;    -  
;**************************************************************
        movwf   temp_w         ;  W
        swapf   STATUS,w       ;  Status
        bcf     STATUS,RP0     ;  0
        movwf   temp_s         ; c  PUSH
;---------     !!! ------------------
        movf    FSR,w          ;  fsr
        movwf   temp_fsr       ;
;-------   -------------------------------------
        btfsc   RCSTA,2        ;  -  STOP-BIT
        goto    int_gate       ;   
        btfsc   flag_0         ;    
        goto    int_wait00     ;     =00=
        btfsc   flag_1         ;
        goto    int_reciv      ;   
        btfsc   flag_2         ;
        goto    int_write      ;   
        clrf    Flagsdmx       ;  
        mov     rx,RCREG       ;   
        goto    ret_int        ;   
;---------------------------------------------------------------
int_wait00:                    ;   =00=
        mov     rx,RCREG       ;   
        mvi     tekuch,1       ;  
        cpi     rx,0x00        ;   =00=  
        jnz     ret_int        ;    
        bcf     flag_0         ;   
        bsf     flag_1         ; .  
        goto    ret_int        ;  =00=   
;---------------------------------------------------------------
int_reciv:                     ;    
        bcf     flag_0         ;   
        bsf     flag_1         ; .  
        mvi     channel,1      ;  
        cmp     tekuch,first   ;    
        jz      int_write      ;    
        mov     rx,RCREG       ;   
        incf    tekuch,f       ;   DMX
        goto    ret_int        ;   
;---------------------------------------------------------------
int_write:
        bcf     flag_1         ; c  
        bsf     flag_2         ; .  
        mvi     FSR,dmx_0      ; 
        movf    channel,w      ;   
        addwf   FSR,f          ;  
        mov     INDF,RCREG     ;   
        incf    channel,f      ;  
        cpi     channel,.7     ;  
        jnz     ret_int        ;    
        clrf    Flagsdmx       ; c  - 
        goto    ret_int        ;   
;---------------------------------------------------------------
int_gate:        ;    DMX
        bsf     flag_0         ; .  
        mov     rx,RCREG       ;   
ret_int:
        bcf     PIR1,5         ; USART -  !!!
        movf    temp_fsr,w     ;
        movwf   FSR            ; return fsr
        swapf   temp_s,w       ; c  POP
        movwf   STATUS         ;  Status
        swapf   temp_w,f       ;  W 
        swapf   temp_w,w       ;   Z !
        retfie      ;       
;//////////////////////////////////////////////////////////////
;**************************************************************
        ORG     500h           ;  PCLATH = 300h
;************************************************************
GoboMove: ; Gobo =    
;************************************************************
        cmp  GoboRun,GoboLevel ;  Gobo  
        jz   NewsGobo            ;  
        cpi  Gobocount,.010      ;    
        btfsc   STATUS,CR   ;     
        return              ;  
        clrf    Gobocount   ;   
        mvi     PCLATH,5    ;     
        cmp  GoboRun,GoboLevel  ;   
        jc   GoboLeft             ;   
;-------------------------------------------------------------
; --------      -----------------
;-------------------------------------------------------------
        movf    Shimswith,w ;   
        addwf   PC,f        ;    
        goto    decShim4    ;
        goto    decShim1    ;
        goto    decShim2    ;
        goto    decShim3    ;
newSwithR:
        decf    GoboRun,f ;    = 1 
        decf    Shimswith,f ;     
        movlw   b'00000011' ; (   )
        andwf   Shimswith,f ;   
        return
;-------------------------------------------------------------
GoboLeft: ; Gobo =     
;-------------------------------------------------------------
        movf    Shimswith,w ;   
        addwf   PC,f        ;    
        goto    incShim1    ;
        goto    incShim2    ;
        goto    incShim3    ;
        goto    incShim4    ;
newSwithL:
        incf    GoboRun,f ;    = 1 
        incf    Shimswith,f ;     
        movlw   b'00000011' ; (   )
        andwf   Shimswith,f ;   
        return
;-------------------------------------------------------------
NewsGobo: ;    Gobo
        swapf   GoboInput,w       ;  16 
        clrf    PCLATH            ;
        call    TabGobo           ;   
        movwf   GoboLevel         ;   
        bsf     FlagEnable        ;
        return
;-==========================================================--
decShim1:
        cpi     CCPR1L,.240 ;   , 
        jnc   newSwithR     ;   
        movf  GoboSpeed,w ;    SUNRISE  
         addwf   CCPR1L,f    ;    
        return              ;    
;-------------------------------------------------------------
decShim2:
        cpi     CCPR2L,.016 ;   , 
        jc    newSwithR     ;   
        movf  GoboSpeed,w ;    SUNRISE  
        subwf   CCPR2L,f    ;    
        return              ;    
;-------------------------------------------------------------
decShim3:
        cpi     CCPR1L,.016 ;   , 
        jc    newSwithR     ;   
        movf  GoboSpeed,w ;    SUNRISE  
        subwf   CCPR1L,f    ;    
        return              ;    
;-------------------------------------------------------------
decShim4:
        cpi     CCPR2L,.240 ;   , 
        jnc   newSwithR     ;   
        movf  GoboSpeed,w ;    SUNRISE  
        addwf   CCPR2L,f    ;    
        return              ;    
;-------------------------------------------------------------
incShim1:
        cpi     CCPR1L,.016 ;   , 
        jc    newSwithL     ;   
        movf  GoboSpeed,w ;    SUNRISE  
        subwf   CCPR1L,f    ;    
        return              ;    
;-------------------------------------------------------------
incShim2:
        cpi     CCPR2L,.240 ;   , 
        jnc   newSwithL     ;   
        movf  GoboSpeed,w ;    SUNRISE  
        addwf   CCPR2L,f    ;    
        return              ;    
;-------------------------------------------------------------
incShim3:
        cpi     CCPR1L,.240 ;   , 
        jnc   newSwithL     ;   
        movf  GoboSpeed,w ;    SUNRISE  
        addwf   CCPR1L,f    ;    
        return              ;    
;-------------------------------------------------------------
incShim4:
        cpi     CCPR2L,.016 ;   , 
        jc    newSwithL     ;   
        movf  GoboSpeed,w ;    SUNRISE  
        subwf   CCPR2L,f    ;    
        return              ;    
;************************************************************
;============================================================
;************************************************************
        ORG     600h
;************************************************************
;============================================================
;-------------------------------------------------------------
ScanYRightSqw: ;  , ,  
        decf    ScanYSqw,f    ;  
        mvi     PCLATH,6      ;     
        movf    ScanYswith,w  ;  
        andlw   b'00000011'   ; (   )
        addwf   PC,f
        goto    ScanY1varR4   ; 4
        goto    ScanY1varR3   ; 3
        goto    ScanY1varR2   ; 2
        goto    ScanY1varR1   ; 1
;-------------------------------------------------------------
ScanYLeftSqw: ;  , ,  
        incf    ScanYSqw,f    ;  
        mvi     PCLATH,6      ;     
        movf    ScanYswith,w  ;
        andlw   b'00000011'   ; (   )
        addwf   PC,f
        goto    ScanY1varL3   ;
        goto    ScanY1varL2   ;
        goto    ScanY1varL1   ;
        goto    ScanY1varL4   ;
;=============================================================
ScanY1varR1: ;     
        cmp     ScanYSqw,ScanYstep  ;   
        btfsc   STATUS,0        ;
        goto    cst100010       ;   - 1->0
        goto    cst100100       ;   - 0->1
;-------------------------------------------------------------
ScanY1varR2: ;     
        cmp     ScanYSqw,ScanYstep  ;   
        btfsc   STATUS,0
        goto    cst010010       ;   - 1->0
        goto    cst100010       ;   - 0->1
;-------------------------------------------------------------
ScanY1varR3: ;     
        cmp     ScanYSqw,ScanYstep  ;   
        btfsc   STATUS,0
        goto    cst010100       ;   - 1->0
        goto    cst010010       ;   - 0->1
;-------------------------------------------------------------
ScanY1varR4: ;     
        cmp     ScanYSqw,ScanYstep  ;   
        btfsc   STATUS,0
        goto    cst100100       ;   - 1->0
        goto    cst010100       ;   - 0->1
;=============================================================
ScanY1varL1: ;     
        cmp     ScanYSqw,ScanYstep ;   
        btfss   STATUS,0        ;
        goto    cst100010       ;   - 1->0
        goto    cst100100       ;   - 0->1
;-------------------------------------------------------------
ScanY1varL2: ;     
        cmp     ScanYSqw,ScanYstep ;   
        btfss   STATUS,0
        goto    cst010010       ;   - 1->0
        goto    cst100010       ;   - 0->1
;-------------------------------------------------------------
ScanY1varL3: ;     
        cmp     ScanYSqw,ScanYstep ;   
        btfss   STATUS,0
        goto    cst010100       ;   - 1->0
        goto    cst010010       ;   - 0->1
;-------------------------------------------------------------
ScanY1varL4: ;     
        cmp     ScanYSqw,ScanYstep ;   
        btfss   STATUS,0
        goto    cst100100       ;   - 1->0
        goto    cst010100       ;   - 0->1
;=============================================================
cst100010:           ; 1
     bsf  ScanYa       ;    =A= 
     bcf  ScanYb       ;    =B= 
     clrf PCLATH
     return          ;
cst100100:           ; 2
     bsf  ScanYa       ;    =A= 
     bsf  ScanYb       ;    =B= 
     clrf PCLATH
     return          ;
cst010010:           ; 3
     bcf  ScanYa       ;    =A= 
     bcf  ScanYb       ;    =B= 
     clrf PCLATH
     return          ;
cst010100:           ; 4
     bcf  ScanYa       ;    =A= 
     bsf  ScanYb       ;    =B= 
     clrf PCLATH
     return          ;
;============================================================
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;============================================================
ScanXLeftSqw: ;  , ,  
        incf    ScanXsqw,f    ;  
        mvi     PCLATH,6      ;     
        movf    ScanXswith,w  ;
        andlw   b'00000011'   ; (   )
        addwf   PC,f
        goto    ScanX1varL3   ;
        goto    ScanX1varL2   ;
        goto    ScanX1varL1   ;
        goto    ScanX1varL4   ;
;-------------------------------------------------------------
ScanXRightSqw: ;  , ,  
        decf    ScanXsqw,f    ;  
        mvi     PCLATH,6      ;     
        movf    ScanXswith,w  ;  
        andlw   b'00000011'   ; (   )
        addwf   PC,f
        goto    ScanX1varR4   ; 4
        goto    ScanX1varR3   ; 3
        goto    ScanX1varR2   ; 2
        goto    ScanX1varR1   ; 1
;-------------------------------------------------------------
ScanX1varR1: ;     
        cmp     ScanXsqw,ScanXstep;   
        btfsc   STATUS,0        ;
        goto    ust100010       ;   - 1->0
        goto    ust100100       ;   - 0->1
;-------------------------------------------------------------
ScanX1varR2: ;     
        cmp     ScanXsqw,ScanXstep;   
        btfsc   STATUS,0
        goto    ust010010       ;   - 1->0
        goto    ust100010       ;   - 0->1
;-------------------------------------------------------------
ScanX1varR3: ;     
        cmp     ScanXsqw,ScanXstep;   
        btfsc   STATUS,0
        goto    ust010100       ;   - 1->0
        goto    ust010010       ;   - 0->1
;-------------------------------------------------------------
ScanX1varR4: ;     
        cmp     ScanXsqw,ScanXstep;   
        btfsc   STATUS,0
        goto    ust100100       ;   - 1->0
        goto    ust010100       ;   - 0->1
;=============================================================
ScanX1varL1: ;     
        cmp     ScanXsqw,ScanXstep;   
        btfss   STATUS,0        ;
        goto    ust100010       ;   - 1->0
        goto    ust100100       ;   - 0->1
;-------------------------------------------------------------
ScanX1varL2: ;     
        cmp     ScanXsqw,ScanXstep;   
        btfss   STATUS,0
        goto    ust010010       ;   - 1->0
        goto    ust100010       ;   - 0->1
;-------------------------------------------------------------
ScanX1varL3: ;     
        cmp     ScanXsqw,ScanXstep;   
        btfss   STATUS,0
        goto    ust010100       ;   - 1->0
        goto    ust010010       ;   - 0->1
;-------------------------------------------------------------
ScanX1varL4: ;     
        cmp     ScanXsqw,ScanXstep;   
        btfss   STATUS,0
        goto    ust100100       ;   - 1->0
        goto    ust010100       ;   - 0->1
;=============================================================
ust100010:             ; 1
     bsf  ScanXa       ;    =A= 
     bcf  ScanXb       ;    =B= 
     clrf PCLATH
     return            ;
ust100100:             ; 2
     bsf  ScanXa       ;    =A= 
     bsf  ScanXb       ;    =B= 
     clrf PCLATH
     return            ;
ust010010:             ; 3
     bcf  ScanXa       ;    =A= 
     bcf  ScanXb       ;    =B= 
     clrf PCLATH
     return            ;
ust010100:             ; 4
     bcf  ScanXa       ;    =A= 
     bsf  ScanXb       ;    =B= 
     clrf PCLATH
     return             ;
;////////////////////////////////////////////////////////////
ScanYMove:  ; +++++++++++++++++++++++++++++++++++++++++++++++
;////////////////////////////////////////////////////////////
        cmp  ScanYrun,ScanYLevel ;   
        jc   ScanYLeft           ;   
;-------------------------------------------------------------
ScanYRight:    ;  
;-------------------------------------------------------------
        call ScanYRightSqw ;  , ,  
        cmp     ScanYrun,ScanYLevel ;   
        jz      NewsY
        movf    ScanYSpeed,w  ;  : c
        subwf   ScanYcount,w  ;   
        btfss   STATUS,CR     ;   
        return                ; ,  
        clrf    ScanYcount    ;   
;-------------------------------------------------------------
        incf    ScanYstep,f   ;   
        rnz                    ;   = 0  
;-------------------------------------------------------------
;       
        decf    ScanYrun,f    ;   
        decf    ScanYswith,f  ;    
;-------------------------------------------------------------
;      RUN-LEVEL
        movf   ScanYLevel,w ; 1- 255-
        subwf  ScanYrun,w   ; run(reg)-level(W)=
        movwf  ScanYSpeed      ; 
        goto   ComputYspeed
;-------------------------------------------------------------
ScanYLeft:  ;  
;-------------------------------------------------------------
  call ScanYLeftSqw ;  , ,  
        cmp     ScanYrun,ScanYLevel ;   
        jz      NewsY

        movf    ScanYSpeed,w  ;  : c
        subwf   ScanYcount,w  ;   
        btfss   STATUS,CR     ;   
        return                ; ,  
        clrf    ScanYcount    ;   
;-------------------------------------------------------------
        incf    ScanYstep,f   ;   
        rnz                   ;   = 0  
;-------------------------------------------------------------
;       
        incf    ScanYrun,f    ;   
        incf    ScanYswith,f  ; ???    
;-------------------------------------------------------------
;      RUN-LEVEL
        movf   ScanYrun,w     ; 1- 255-
        subwf  ScanYLevel,w
        movwf  ScanYSpeed      ; 
;-------------------------------------------------------------
ComputYspeed:
        cpi    ScanYSpeed,1  ;   
        jz     Yspeed1
        cpi    ScanYSpeed,2  ;  
        jz     Yspeed2
        cpi    ScanYSpeed,3  ;  
        jz     Yspeed3
        mvi    ScanYSpeed,2  ;  
        return
Yspeed1:
        mvi    ScanYSpeed,.7  ;   
        return
Yspeed2:
        mvi    ScanYSpeed,.4  ;  
        return
Yspeed3:
        mvi    ScanYSpeed,.3  ;   
        return
;-------------------------------------------------------------
NewsY:         ;
        btfss   FlagEnable        ;   INIT
        return
        mvi     ScanYSpeed,.10 ;  
        swapf   ScanYinput,w
        andlw   b'00001111'
        movwf   ScanYLevel
        rrf     ScanYLevel,w    ;
        andlw   b'00000111'
        addwf   ScanYLevel,f
        cpi     ScanYLevel,.21  ;
        rnc                     ;
        mvi     ScanYLevel,.21
        return
;//////////////////////////////////////////////////////////
ScanXMove:  ; ++++++++++++++++++++++++++++++++++++++++++++
;//////////////////////////////////////////////////////////
        cmp  ScanXrun,ScanXLevel ;   
        jc   ScanXLeft           ;   
;-------------------------------------------------------------
ScanXRight:    ;  
;-------------------------------------------------------------
        call  ScanXRightSqw ;  , ,  
        cmp     ScanXrun,ScanXLevel ;   
        jz      NewsX
        movf    ScanXSpeed,w  ;  : c
        subwf   ScanXcount,w  ;   
        btfss   STATUS,CR     ;   
        return                ; ,  
        clrf    ScanXcount    ;   
;-------------------------------------------------------------
        incf    ScanXstep,f   ;   
        rnz                    ;   = 0  
        decf    ScanXrun,f    ;   
        decf    ScanXswith,f  ;    
;-------------------------------------------------------------
;      RUN-LEVEL
        movf   ScanXLevel,w ; 1- 255-
        subwf  ScanXrun,w   ; run(reg)-level(W)=
        movwf  ScanXSpeed      ; 
        goto   ComputXspeed
;-------------------------------------------------------------
ScanXLeft:  ;  
;-------------------------------------------------------------
        call  ScanXLeftSqw ;  , ,  
        cmp     ScanXrun,ScanXLevel ;   
        jz      NewsX
        movf    ScanXSpeed,w  ;  : c
        subwf   ScanXcount,w  ;   
        btfss   STATUS,CR     ;   
        return                ; ,  
        clrf    ScanXcount    ;   
;-------------------------------------------------------------
        incf    ScanXstep,f   ;   
        rnz                   ;   = 0  
        incf    ScanXrun,f    ;   
        incf    ScanXswith,f  ; ???    
;-------------------------------------------------------------
;      RUN-LEVEL
        movf   ScanXrun,w     ; 1- 255-
        subwf  ScanXLevel,w
        movwf  ScanXSpeed      ; 
;-------------------------------------------------------------
ComputXspeed:
        cpi    ScanXSpeed,1  ;   
        jz     Xspeed1
        cpi    ScanXSpeed,2  ;  
        jz     Xspeed2
        cpi    ScanXSpeed,3  ;  
        jz     Xspeed3
        cpi    ScanXSpeed,4  ;  
        jz     Xspeed4
        mvi    ScanXSpeed,2  ;  
        return
Xspeed1:
        mvi    ScanXSpeed,.7  ;   
        return
Xspeed2:
        mvi    ScanXSpeed,.5  ;  
        return
Xspeed3:
        mvi    ScanXSpeed,.4  ;   
        return
Xspeed4:
        mvi    ScanXSpeed,.3  ;   
        return
;----------------------------------------------------------
NewsX: ;  a
        btfss   FlagEnable        ;   INIT
        return                    ;
        movf    ScanXinput,w
        movwf   ScanXLevel
        rrf     ScanXLevel,f    ;
        rrf     ScanXLevel,f    ;
        rrf     ScanXLevel,f    ;
        movlw   b'00011111'
        andwf   ScanXLevel,f    ;
;----------------------------------------------------------
        mvi     ScanXSpeed,.10  ;  
        return
;**************************************************************
  End  ;    BrSoft Copyright (C) 2004 Bogdanov Andrew
;**************************************************************






