;*************************************************************
;  (DMX)      
;   ,  220   (8 ).
;      - 
;************************************************************
;   Filename:           zersroll.asm
;   First Date:         3 november 2002
;   Last  Date:         8 november 2002
;   File Version:       1.00
;   Assembler:          mpasm 1.40
;   Author:             Bogdanov Andrew
;   E-Mail:             BrSoft@tsrv.ru
;   Info:               Book N4 page
;************************************************************
;  LIST   p=16C73  ; cp=off=1. 3pwrt|on=1. 2wdt|on=1. =HS   *
 __CONFIG b'11111111111110'        ;        *
;************************************************************
#include pic73mac.inc ;                                     *
;************************************************************
;           Bit Definitions                                 *
;************************************************************
#define  flag_0   Flagsdmx,0  ;                       *
#define  flag_1   Flagsdmx,1  ;                *
#define  flag_2   Flagsdmx,2  ;                  *
#define  flag_3   Flagsdmx,3  ;  DMX                 *
;************************************************************
#define  Fstop1   Flags1,0 ; =1= :,=0 =1
#define  Fweit    Flags1,1 ;   
#define  Fstop    Flags1,2 ;   - 
;******************** Ports Bits ****************************
#define  Musik     PortA,0     ; port A -         *
#define  Optron    PortC,5     ; port C -  optrona      *
#define  GoboMotor PortA,1     ; port A -    *
;************************************************************
;           Register Definitions  20h - 7fh
;******  Roller *************************************
Rollstep1  equ   0x20  ; Roller 1   
Rollcount1 equ   0x21  ; Roller 1  
Rollswith1 equ   0x22  ; Roller 1  
RollSqw1   equ   0x23  ; Roller 1   
;************************************************************
count_g1   equ   0x30  ; (+RTCC)  
count_g2   equ   0x31  ;   
GoboDisc   equ   0x32  ;   0-7   
GoboDmx    equ   0x33  ;  (0-7)   
GoboMode   equ   0x34  ;    
AdrGobo    equ   0x35  ;    Gobo
AdrRoll    equ   0x36  ;    Rollers
Rtr_1      equ   0x37  ;   Roller 1
;************************************************************
Flags1    equ   0x40   ; ,   
count_p1  equ   0x41   ; (+RTCC)    LB
count_p2  equ   0x42   ;     HB
count_p3  equ   0x43   ;    
count_m1  equ   0x44   ; (+RTCC)music      LB
count_m2  equ   0x45   ; music      HB
count_r1  equ   0x46   ; (+RTCC)    "a"
count_r2  equ   0x47   ;     "a"
count_d1  equ   0x48   ; (+RTCC)  
count_d2  equ   0x49   ;    =Gobo=
;*************************************************************
dmx_0       equ  0x50   ; 0-  DMX
dmx_1       equ  0x51   ; 1-  DMX
dmx_2       equ  0x52   ; 2-  DMX
dmx_3       equ  0x53   ; 3-  DMX
dmx_4       equ  0x54   ; 4-  DMX
dmx_5       equ  0x55   ; 5-  DMX
dmx_6       equ  0x56   ; 6-  DMX
dmx_7       equ  0x57   ; 7-  DMX
dmx_8       equ  0x58   ; 8-  DMX
dmx_9       equ  0x59   ; 9-  DMX
dmx_10      equ  0x5A   ; 10-  DMX
dmx_11      equ  0x5B   ; 11-  DMX
dmx_12      equ  0x5C   ; 12-  DMX
;-------------------------------------------------------------
lev_0       equ  0x60   ; 0-       
lev_1       equ  0x61   ; 1 = Roller 1     
lev_2       equ  0x62   ; 2 = Roller 2     
lev_3       equ  0x63   ; 3 = Roller 3     
lev_4       equ  0x64   ; 4 = Roller 4      
lev_5       equ  0x65   ; 5 = Maska     
lev_6       equ  0x66   ; 6 = 
lev_7       equ  0x67   ; 7-
lev_8       equ  0x68   ; 8-
lev_9       equ  0x69   ; 9-
lev_10      equ  0x6A   ; 10-
lev_11      equ  0x6B   ; 11-
lev_12      equ  0x6C   ; 12-
;*************    DMX *************************
Flagsdmx  equ   0x70     ; \   
temp_cnt  equ   0x71     ; \ Int    
temp_rx   equ   0x72     ; \ Int     
temp_s    equ   0x73     ; \ Int  
temp_w    equ   0x74     ; \ Int          
rx        equ   0x75     ;   DMX
mode_int  equ   0x76     ;    
first     equ   0x77     ;    
tekuch    equ   0x78     ;    
channel   equ   0x79     ;    
;*************************************************************
konst_d    equ   d'090'  ;  
; 1-20    , 160-255   
konst_gate equ   d'020'  ;    
; 007-   ,32-   
konst_r    equ   d'150'  ;     
; 75 = 120   
konst_m    equ   d'070'  ;     
konst_p    equ   d'250'  ;     1sec
konst_l    equ   d'060'  ;    (60-1?)
;*************************************************************
        ORG     0        ;  
        goto    Start    ;    
        nop              ;
        nop              ;
        nop              ;  = 0004h
        goto    int_dmx  ;    -  
;*************************************************************
TabSpeed: addwf PC,f;002-1  2, 250-1  4
 dt  .002,.003,.004,.005,.006,.007,.008,.010
 dt  .014,.020,.027,.035,.050,.100,.200,.250
;*************************************************************
TabGobo:   addwf PC,F    ; 8  
; Data    , 
;-----------------------------------------------------------------------
;    :   0  31
    dt  0x10,0x10,0x10,0x30,0x30,0x30,0x50,0x50 ;
    dt  0x50,0x70,0x70,0x70,0x90,0x90,0x90,0xB0 ;
    dt  0xB0,0xB0,0xD0,0xD0,0xD0,0xF0,0xF0,0xF0 ;
    dt  0x10,0xF0,0x10,0xF0,0x10,0xF0,0x10,0xF0 ;
;    :   31 63
    dt  0x10,0x10,0x10,0x10,0x10,0x30,0x30,0x30 ;
    dt  0x30,0x30,0x30,0x50,0x50,0x50,0x50,0x50 ;
    dt  0x70,0x70,0x70,0x70,0x70,0x90,0x90,0x90 ;
    dt  0x90,0x90,0xB0,0xB0,0xB0,0xB0,0xD0,0xD0 ;
LongGobo   equ   d'061'  ;   
;***********************************************************************
TabRoller:  addwf   PC,F ; 16   
; Data    , 80=
; 0-7F  (0-),80-FF  (FF-)
;-----------------------------------------------------------------------
;    :   0  31
    dt  0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF ; 00 \ FF
    dt  0xAF,0xAF,0xAF,0xAF,0x50,0x50,0x50,0x50 ; 10 \ EF
    dt  0x30,0x30,0xCF,0xCF,0x30,0x30,0xCF,0xCF ; 20 \ DF
    dt  0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70 ; 30 \ CF
;    :   32  63
    dt  0x00,0x80,0xFF,0x80,0x00,0x80,0xFF,0x80 ; 40 \ BF
    dt  0x00,0x80,0xFF,0x80,0x00,0x80,0xFF,0x80 ; 50 \ AF
    dt  0x10,0x10,0xEF,0xEF,0x10,0x10,0xEF,0xEF ; 60 \ 9F
    dt  0x20,0xDF,0x20,0xDF,0x20,0xDF,0x20,0xDF ; 70 \ 8F
;    :   64  95
    dt  0x10,0x20,0x30,0x40,0x50,0x60,0x70,0x80 ;
    dt  0x8F,0x9F,0xAF,0xBF,0xCF,0xDF,0xEF,0xFF ;
    dt  0x40,0xFF,0x40,0xFF,0x40,0xFF,0x40,0xFF ;
    dt  0x00,0xAF,0x00,0xAF,0x00,0xAF,0x00,0xAF ;
;    :   96  127
    dt  0x10,0xEF,0x80,0x10,0xEF,0x80,0x10,0xEF ;
    dt  0x80,0x10,0xEF,0x80,0x10,0xEF,0x80,0xFF ;
    dt  0x70,0x9F,0x50,0xBF,0x30,0xDF,0x10,0xFF ;
    dt  0x8F,0x8F,0x8F,0x8F,0x8F,0x8F,0x8F,0x80 ;
LongRoll   equ   d'125'  ; 125   
;***********************************************************************
Start:                              ; Main Programm
            bsf         Status,RP0  ; c 1
            movlw       b'00111101' ; A0-in;A1-out
            movwf       TrisA       ;
            movlw       b'11111111' ; B0-B7 - inputs
            movwf       TrisB       ;
            movlw       b'10110000' ; C0-C3-out;C4,C5-in
            movwf       TrisC       ; C7=RX,C6=TX
            movlw       b'00000011' ; HS->Prescaler->Timer0,
            movwf       OptionR     ; 1:16
            movlw       b'00000111' ;  
            movwf       ADCON1      ;
            movlw       b'00100000' ;  
            movwf       PIE1        ; USART
            movlw       d'000'      ; =0, brg=0
            movwf       SPBRG       ; USART
            movlw       b'00100010' ;  BRGH =1 high
            movwf       TXSTA       ; USART      bit2 =0 low
            bcf         Status,RP0  ; c 0
;*************************************************************
            movlw       b'10010000' ;  
            movwf       RCSTA       ; USART
            movlw       b'00000000' ; (bit 5 = 0   data
            movwf       PIR1        ; USART -  !!!
            movlw       b'11000000' ;  
            movwf       INTCON      ; 
;------------------------------------------------------------
          clrf  PortA      ;  
          clrf  PortC      ;
        movlw   0x20       ; 
        movwf   Fsr        ; 
clear_mem:                 ;
        clrf    Indf       ; 
        incf    Fsr,f      ;
        cpi     Fsr,0x7e   ;
        jnz     clear_mem  ;
            clrwdt         ;  WDT 
        call    InitGobo   ;
;*************************************************************
;******************* Code Main Program ***********************
;*************************************************************
base_cuc:                 ;
        clrwdt            ;  WDT 
;  GOTO  Prog_Music
     movf  PortB,w        ;   
     andlw b'01111111'    ;      W
     movwf first          ;   DMX
     cpi   first,0        ; ??? <<<<<<<<<<<<<<<<
     jz    Prog_Music     ;   
;------   DMX  ---------------------------
     mov     lev_1,dmx_1  ;  
     mov     lev_5,dmx_2  ;    
     swapf   lev_5,f      ; 
     rrf     lev_5,f      ;   0-7
     movlw   b'00000111'  ;
     andwf   lev_5,f      ;
;------      -----------------
Order:
        call    PlusTimer    ;   
        call    Roller1      ;    - 
        call    GoboJob      ;
        goto    base_cuc     ;
;--------------------------------------------------------------
Prog_Music:
        btfss   PortB,7      ;   
        goto   mode_program  ; ,   Programma
        goto   mode_music    ; ,  .
;***********************************************************************
mode_music:                  ;     
        call    posle        ; 2 sec   
        btfss   Fstop        ;
        goto  StopMotors     ;  
        mov     lev_1,Rtr_1  ;  Data
        btfsc   Fweit        ;    
        goto    mus_gate     ;  =1,  
        movlw   0ffh         ;  ,
        subwf   count_m1,w   ;    
        jnc     Order        ; ,      
        clrf    count_m1     ; ,
        incf    count_m2,f
        movlw   konst_m      ;    
        subwf   count_m2,w   ;
        jnz     Order        ; ,      
        clrf    count_m2     ;   
        bsf     Fweit        ; . (=1)  
        goto    Order        ;  
StopMotors:
     mvi     Rtr_1,0x80   ;  Rollers
     mov     lev_1,Rtr_1  ;  Data
     goto    Order        ;  
;-----------------------------------------------------------------------
mus_gate:
        btfss   Musik     ;   ?
        goto    Order     ;  
        bcf     Fweit     ; . -   
        goto    Komands   ;    
;---------------   ----------------------------------------
mode_program:
        mov     lev_1,Rtr_1    ;  Data
        movlw   0Efh           ;  
        subwf   count_r1,w     ;  
        jnc     Order          ;     
        clrf    count_r1       ;  
        incf    count_r2,f     ;
        movlw   konst_r        ;  
        subwf   count_r2,w     ;  
        jnz     Order          ;     
        clrf    count_r2       ;  
;---------------------------------------------------------------------
Komands:
     call    ProgGobo     ;   Gobo
     call    ProgRoller   ;    Roller
     swapf   lev_5,f      ; 
     rrf     lev_5,f      ;   0-7
     movlw   b'00000111'  ;
     andwf   lev_5,f      ;
     mov     lev_1,Rtr_1  ;  Data
     goto    Order        ;  
;***********************************************************************
posle:                     ;    2  
        btfss   Musik      ;   
        goto    posl_nogate;    ?
        bsf     Fstop      ; ,   
        clrf    count_p1   ;   
        clrf    count_p2   ;   
        clrf    count_p3   ;  
        ret
posl_nogate:                   ;   =Musik=
        movlw   0Efh           ;    
        subwf   count_p1,w     ;
        jnc     posl_ret       ; ret,      
        clrf    count_p1       ;   
        incf    count_p2,f     ;
        movlw   konst_p        ;    
        subwf   count_p2,w     ;
        jnz     posl_ret       ; ret,      
        clrf    count_p2       ;   
        bcf     Fstop  ; ,   
        goto    posl_ret
    incf    count_p3,f      ;
    movlw   konst_l         ;    
    subwf   count_p3,w      ;
    jnz     posl_ret        ; ret,      
;   bcf     Flamp   ;  
posl_ret:
        ret
;***********************************************************************
ProgRoller: ;      Rollers
        movf    AdrRoll,W       ;   -> W
        call    TabRoller       ;  -> W
        movtof  Rtr_1           ; Roller
        incf    AdrRoll,f       ;  
        cpi     AdrRoll,LongRoll;   
        rnz                     ;   arg < const
        clrf    AdrRoll
        return
;***********************************************************************
ProgGobo:   ;       Gobo
        movf    AdrGobo,W       ;   -> W
        call    TabGobo         ;  -> W
        movtof  lev_5           ; gobo
        incf    AdrGobo,f       ;  
        cpi     AdrGobo,LongGobo;   
        rnz                     ;   arg < const
        clrf    AdrGobo
        return
;************************************************************
InitGobo:                    ;   
        bsf     GoboMotor    ;   =Gobo=
InitClrf:
        clrf    count_g1     ;  1  
        clrf    count_g2     ;  2  
        clrwdt               ;  WDT 
        btfsc   Optron       ;   
        goto    InitClrf     ;  Gobo,  
InitCuc1:
        call    PlusTimer    ;   
        movlw   0EFh         ;    
        subwf   count_g1,w   ;
        jnc     InitCuc1     ;      
        clrf    count_g1     ;  

        btfsc   Optron       ;   
        goto    Init_time    ;  Gobo,  

        incf    count_g2,f   ;
        jnz     InitCuc1     ;     
        clrf    count_g2     ;  
        clrf    GoboMode     ;    0
        bcf     GoboMotor    ;   Gobo
        return
Init_time:                   ; ,  
        movlw   konst_gate   ;    
        subwf   count_g2,w   ;  
        jnc     InitClrf     ;  - 
;       mvi     GoboMode,1   ;   
        return
;************************************************************
GoboJob:
        cpi     GoboMode,1   ;  0.5 
        jz      DelayGobo    ;
        cpi     GoboMode,2   ;   
        jz      LastGobo     ; 
  cmp  GoboDisc,GoboDmx   ;    
        jz      GoboStop     ;    
        goto    DelayGobo    ;  
GoboStop:                    ;  0
        mov     GoboDmx,lev_5;
        bcf     GoboMotor    ;   Gobo
        clrf    GoboMode     ;   . Gobo
        clrf    count_d1     ;   ->0
        clrf    count_d2     ;   ->0
        return
;-------------------------------------------------------------
DelayGobo:                   ;  0.5  - 
        mvi     GoboMode,1   ;  1
        bsf     GoboMotor    ;   =Gobo=
        movlw   0EFh         ;    
        subwf   count_d1,w   ; jnc !!!
        jnc     DG_ret       ; ret,      
        clrf    count_d1     ;   MIDLE
     incf    count_d2,f      ;
     movlw   konst_d         ;    
     subwf   count_d2,w      ;
     jnc     DG_ret          ; ret,    
       clrf    count_d2     ;   MIDLE
        mvi     GoboMode,2   ; ,   2
        goto    DG_ret
DG_ret:
        return
;-------------------------------------------------------------
LastGobo:        ;  2   ;    
        btfsc   Optron       ;   
        return               ;  Gobo,  
        incf    GoboDisc,f   ;   
        movlw   0x07         ;  
        andwf   GoboDisc,f   ;   = 8 (0-7)
     cmp  GoboDisc,GoboDmx   ;    
        jz      GoboStop     ;    
        mvi     GoboMode,1   ;   1,  
        return
;************************************************************
Roller1:                     ;   1
        cpi     lev_1,.121   ;
        btfsc   Status,0     ;
        goto    Roll1direct  ;
        cpi     lev_1,.134   ;
        btfsc   Status,0     ;
        return               ;
Roll1direct:                 ;
        btfss   lev_1,7      ;   0-,1-
        goto    Roll1_left   ;  0    
;*************************************************************
Roll1_right: ;     1
;*************************************************************
        comf    lev_1,f     ;   co
        rrf     lev_1,f
        rrf     lev_1,f
        rrf     lev_1,f
        movlw   b'00001111'
        andwf   lev_1,w
        call    TabSpeed    ;   
        subwf   Rollcount1,w;   
        btfss   Status,CR   ;   
        goto    cross_r1    ; ,  
        clrf    Rollcount1  ;   
        incf    Rollstep1,f ;   
        jnz     cross_r1    ;   = 0  
        decf    Rollswith1,f;     
        movlw   b'00000011' ; (   )
        andwf   Rollswith1,f;   
cross_r1:                   ;
        decf    RollSqw1,f  ;  
        movlw   1           ;    
        subwf   Rollswith1,w;     
        jz      Roll1varR2  ; 2
        movlw   2           ;    
        subwf   Rollswith1,w;     
        jz      Roll1varR3  ; 3
        movlw   3           ;    
        subwf   Rollswith1,w;     
        jz      Roll1varR4  ; 4
;-------------------------------------------------------------
Roll1varR1: ;     
        cmp     RollSqw1,Rollstep1 ;   
        btfsc   Status,0        ;
        goto    ust100010       ;   - 1->0
        goto    ust100100       ;   - 0->1
;-------------------------------------------------------------
Roll1varR2: ;     
        cmp     RollSqw1,Rollstep1 ;   
        btfsc   Status,0
        goto    ust010010       ;   - 1->0
        goto    ust100010       ;   - 0->1
;-------------------------------------------------------------
Roll1varR3: ;     
        cmp     RollSqw1,Rollstep1 ;   
        btfsc   Status,0
        goto    ust010100       ;   - 1->0
        goto    ust010010       ;   - 0->1
;-------------------------------------------------------------
Roll1varR4: ;     
        cmp     RollSqw1,Rollstep1 ;   
        btfsc   Status,0
        goto    ust100100       ;   - 1->0
        goto    ust010100       ;   - 0->1
;*************************************************************
Roll1_left:  ;      1
;*************************************************************
        movf    lev_1,f     ;   co
        rrf     lev_1,f
        rrf     lev_1,f
        rrf     lev_1,f
        movlw   b'00001111'
        andwf   lev_1,w
       call    TabSpeed    ;   
        subwf   Rollcount1,w;   
        btfss   Status,CR   ;   
        goto    cross_l1    ; ,  
        clrf    Rollcount1  ;   
        incf    Rollstep1,f ;   
        jnz     cross_l1    ;   = 0  
        incf    Rollswith1,f; ???    
        movlw   b'00000011' ; (   )
        andwf   Rollswith1,f;   
cross_l1:                   ;
        incf    RollSqw1,f  ;  
        movlw   1           ;    
        subwf   Rollswith1,w;     
        jz      Roll1varL2        ; 2
        movlw   2           ;    
        subwf   Rollswith1,w;     
        jz      Roll1varL3        ; 3
        movlw   3           ;    
        subwf   Rollswith1,w;     
        jz      Roll1varL4        ; 4
        goto    Roll1varL1
;-------------------------------------------------------------
Roll1varL1: ;     
        cmp     RollSqw1,Rollstep1 ;   
        btfss   Status,0        ;
        goto    ust100010       ;   - 1->0
        goto    ust100100       ;   - 0->1
;-------------------------------------------------------------
Roll1varL2: ;     
        cmp     RollSqw1,Rollstep1 ;   
        btfss   Status,0
        goto    ust010010       ;   - 1->0
        goto    ust100010       ;   - 0->1
;-------------------------------------------------------------
Roll1varL3: ;     
        cmp     RollSqw1,Rollstep1 ;   
        btfss   Status,0
        goto    ust010100       ;   - 1->0
        goto    ust010010       ;   - 0->1
;-------------------------------------------------------------
Roll1varL4: ;     
        cmp     RollSqw1,Rollstep1 ;   
        btfss   Status,0
        goto    ust100100       ;   - 1->0
        goto    ust010100       ;   - 0->1
;-------------------------------------------------------------
ust100010:              ; 1
     movf  PortC,w      ;   C -> W
     andlw 0f0h         ;      W
     iorlw b'00001001'  ;     
     movwf PortC        ;      C
     return             ;
ust100100:              ; 2
     movf  PortC,w      ;   C -> W
     andlw 0f0h         ;      W
     iorlw b'00001010'  ;     
     movwf PortC        ;      C
     return             ;
ust010010:              ; 3
     movf  PortC,w      ;   C -> W
     andlw 0f0h         ;      W
     iorlw b'00000101'  ;     
     movwf PortC        ;      C
     return             ;
ust010100:              ; 4
     movf  PortC,w      ;   C -> W
     andlw 0f0h         ;      W
     iorlw b'00000110'  ;     
     movwf PortC        ;      C
     return             ;
;**************************************************************
;      -  
;**************************************************************
int_dmx:                       ;
        movwf   temp_w         ;  W
        swapf   Status,w       ;  Status
        bcf     Status,RP0     ;  0
        movwf   temp_s         ; c  PUSH
;-------   -------------------------------------
        btfsc   RCSTA,2        ;  -  STOP-BIT
        goto    int_gate       ;   
        btfsc   flag_0         ;    
        goto    int_wait00     ;     =00=
        btfsc   flag_1         ;
        goto    int_reciv      ;   
        btfsc   flag_2         ;
        goto    int_write      ;   
        clrf    Flagsdmx       ;  
        mov     rx,RCREG       ;   
        goto    ret_int        ;   
;---------------------------------------------------------------
int_wait00:                    ;   =00=
        mov     rx,RCREG       ;   
        mvi     tekuch,1       ;  
        cpi     rx,0x00        ;   =00=  
        jnz     ret_int        ;    
        bcf     flag_0         ;   
        bsf     flag_1         ; .  
        goto    ret_int        ;  =00=   
;---------------------------------------------------------------
int_reciv:                     ;    
;       bcf     flag_0         ;   
;       bsf     flag_1         ; .  
        mvi     channel,1      ;  
        cmp     tekuch,first   ;    
        jz      int_write      ;    
        mov     rx,RCREG       ;   
        incf    tekuch,f       ;   DMX
        goto    ret_int        ;   
;---------------------------------------------------------------
int_write:
        bcf     flag_1         ; c  
        bsf     flag_2         ; .  
        mvi     FSR,dmx_0      ; 
        movf    channel,w      ;   
        addwf   FSR,f          ;  
        mov     INDF,RCREG     ;   
        incf    channel,f      ;  
        cpi     channel,.13    ;  
        jnz     ret_int        ;    
        clrf    Flagsdmx       ; c  - 
        goto    ret_int        ;   
;---------------------------------------------------------------
int_gate:        ;    DMX
        bsf     flag_0         ; .  
        mov     rx,RCREG       ;   
ret_int:
        swapf   temp_s,w       ; c  POP
        movwf   Status         ;  Status
        swapf   temp_w,f       ;  W 
        swapf   temp_w,w       ;   Z !
        retfie      ;       
;**************************************************************
PlusTimer:                 ;   
        btfss    Timer,2   ;    2
        return             ;   2=0 ->  
        clrf     Timer     ;   2=1 ->    |  
        incf    count_p1,f ;   | 
        incf    count_m1,f ;! .    |  
        incf    count_r1,f ;!    |   
        incf    count_g1,f ;  .   Gobo
        incf    count_d1,f  ;   Gobo
        incf    Rollcount1,f;   =1=
        clrwdt              ;  WDT 
        return
;**************************************************************
;     " BrSoft Copyright (C) 2001 Bogdanov Andrew "
;**************************************************************

           End


